*    FNKSHN foxpro library version 1.01
*    copyright (c) 1996  perry fect
*
*    This library is free software; you can redistribute it and/or
*    modify it under the terms of the GNU Library General Public
*    License as published by the Free Software Foundation; either
*    version 2 of the License, or (at your option) any later version.
*
*    This library is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*    Library General Public License for more details.
*
*    You should have received a copy of the GNU Library General Public
*    License along with this library; if not, write to the Free
*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
procedure zoundex
parameters lcinstr
private lcinstr, lcpref, lccnt1, lcoutstr, lclchar
  if type("LCINSTR")!="C"
    lcinstr=""
  endif
*  lcinstr=upper(lcinstr)
  lcoutstr=upper(lcinstr)
  lcoutstr=strtran(lcoutstr,"PH","F")
  lcoutstr=strtran(lcoutstr,"KN","N")
  lcoutstr=strtran(lcoutstr,"GN","N")
  lcoutstr=strtran(lcoutstr,"ING","N")
  lcpref=left(lcoutstr,1)
  lcoutstr=chrtran(lcoutstr,"ABCDEFGHIJKLMNOPQRSTUVWXYZ -,./*%^&!()123456789",;
                            "01230120022455012623010202000000000000000000000")
  lccnt1=1
  lclchar=" "
  do while .t.
    if lccnt1 > len(lcoutstr)
      exit
    endif
    if substr(lcoutstr,lccnt1,1)=lclchar
      lcoutstr=stuff(lcoutstr,lccnt1,1,"")
      loop
    endif
    lclchar=substr(lcoutstr,lccnt1,1)
    lccnt1=lccnt1+1
  enddo

*  lcoutstr=stuff(lcoutstr,1,1,lcpref)

*  lcoutstr=padr(strtran(lcoutstr,"0",""),4,"0")
  lcoutstr=strtran(lcoutstr,"0","")
return lcoutstr

* ALERTMSG(<message>[,<title>[,<flash>]])
*
* displays an alert box with <message> as text and <title> as the title.
* <flash> determines whether or not to attempt to flash the current window.
* calls LOADLIB(), DLGBOX(), FLASHWIN()
*
procedure alertmsg
parameters lcmsg, lctitle, llflash
private lcmsg, lctitle, llflash, llkeep
external library foxtools
  if type("LCMSG")!="C" or empty(lcmsg)
    lcmsg="Operation failed."
  endif
  if type("LCTITLE")!="C" or empty(lctitle)
    lctitle="System"
  endif
  llkeep="FOXTOOLS" $ set("LIBRARY")
  if loadlib("FOXTOOLS",.t.)
    if llflash
      =flashwin(3,.25)
    endif
    =msgbox(lcmsg,lctitle, 48)
  else
    =dlgbox(lcmsg,lctitle,"OK","    ")
  endif
  =llkeep or killlib("FOXTOOLS")
return

* GONEAR(<alias>)
*
* goes to nearest record (RECNO(0)) in <alias>
*
procedure gonear
parameters lcarea
private lcarea, lnselect
  lnselect=select()
  if type("LCAREA")!="C"
    lcarea=alias()
  endif
  if !used(lcarea)
    return .f.
  endif
  select (lcarea)
  if recno(0) > 0
    goto recno(0)
  else
    go bottom
  endif
  select (lnselect)
return .t.

*  APPBLANK([<alias>[,<expression>])
*
*  Searches for blank record in alias <expc1>, based on
*  EMPTY(<expression>) if included.  Recalls record if deleted.
*  Defaults are current alias.
*
procedure appblank
parameters lcalias, lcexpr
private lcalias, lcexpr, lcsetdel, lnselect, lcfor
  if type("LCALIAS")!="C" or empty(lcalias)
    lcalias=alias()
  endif
  if !used(lcalias)
    return .f.
  endif
  if type("LCEXPR")!="C"
    lcexpr=""
  endif
  lcfor=iif(!empty(lcexpr),"or empty(evaluate(lcexpr))","")
  lcsetdel=set("DELETED")
  lnselect=select()
  select (lcalias)
  set deleted off
  locate for deleted() &lcfor
  if !found()
    append blank
  else
    if val(substr(version(),8,3)) > 2.6
      blank
    else
      scatter memvar memo blank
      gather memvar
    endif
  endif
  recall
  set deleted &lcsetdel
  select (lnselect)
return
* ROPNFIL(<expc1>[,<expc2>],[<expc3>][,<expl>])
*
* Registered open file.
* Opens file <expc1> with order <expc2> in alias <expc3>
* if <expl> is .t., the file is opened exclusively.
* Registers the number of opens in an array maintained
* by REGTAB.
* Calls CHGEXT(), STEM(), NOEXT(), REGTAB()
*
procedure ropnfil
parameters lfdbf, lcorder, lcalias, llexcl
private lfdbf, lcorder, lcalias, llexcl, lcexcl, lnerr, lconerr, lcclause,;
        lcworkarea
  do case
    case type("LFDBF")!="C"
      return .f.
    case !file(chgext(lfdbf,"DBF"))
      return .f.
  endcase
  if type("LCORDER")!="C"
    lcorder=""
  endif
  if type("LCALIAS")!="C" or empty(lcalias)
    lcalias=stem(noext(lfdbf))
  endif
  lcorder=trim(lcorder)
  lcalias=upper(trim(lcalias))
  llopen=opnfil(lfdbf,lcorder,lcalias,llexcl) and regtab("OPEN",lcalias)=0
return llopen

#if .f.
procedure ropnfil
parameters lfdbf, lcorder, lcalias, llexcl
private lfdbf, lcorder, lcalias, llexcl, lcexcl, lnerr, lconerr, lcclause,;
        lcworkarea
  lnerr=0
  lconerr=on("ERROR")
  lcworkarea=select()
  do case
    case type("LFDBF")!="C"
      return .f.
    case !file(chgext(lfdbf,"DBF"))
      return .f.
  endcase
  if type("LCORDER")!="C"
    lcorder=""
  endif
  if type("LCALIAS")!="C" or empty(lcalias)
    lcalias=stem(noext(lfdbf))
  endif
  lcorder=trim(lcorder)
  lcalias=upper(trim(lcalias))
  lcexcl=iif(llexcl,"EXCLUSIVE","")
  if used(lcalias)
    select (lcalias)
    if !empty(lcorder)
      on error lnerr=error()
      set order to &lcorder
      on error &lconerr
    endif
    do case
      case llexcl
        if "EXCL" $ upper(sys(2011))
          if lnerr=0
            =regtab("OPEN",lcalias)
          endif
          select (lcworkarea)
          return lnerr=0
        else
          use in (lcalias)
        endif
      case !llexcl
        if "EXCL" $ upper(sys(2011))
          use in (lcalias)
        else
          if lnerr=0
            =regtab("OPEN",lcalias)
          endif
          select (lcworkarea)
          return lnerr=0
        endif
      otherwise
        return .f.
    endcase
  endif
  lcclause=iif(!empty(lcorder),"ORDER "+lcorder,"")+" "+;
           iif(!empty(lcalias),"ALIAS "+lcalias,"")+" "+;
           lcexcl
  on error lnerr=error()
  use (lfdbf) &lcclause in 0
  on error &lconerr
  if lnerr=0
    =regtab("OPEN",lcalias)
  endif
  select (lcworkarea)
return lnerr=0
#endif
* OPNFIL(<file>[,<order>],[<alias>][,<exclusive>])
*
* Opens <file> tag <order> as <alias>.
* if <exclusive> is .t., the file is opened exclusively.
*
procedure opnfil
parameters lfdbf, lcorder, lcalias, llexcl
private lfdbf, lcorder, lcalias, llexcl, lcexcl, lnerr, lconerr, lcclause,;
        lcworkarea
  lnerr=0
  lconerr=on("ERROR")
  lcworkarea=select()
  do case
    case type("LFDBF")!="C"
      return .f.
    case !file(chgext(lfdbf,"DBF"))
      return .f.
  endcase
  if type("LCORDER")!="C"
    lcorder=""
  endif
  if type("LCALIAS")!="C" or empty(lcalias)
    lcalias=stem(noext(lfdbf))
  endif
  lcorder=trim(lcorder)
  lcalias=upper(trim(lcalias))
  lcexcl=iif(llexcl,"EXCLUSIVE","")
  if used(lcalias)
    select (lcalias)
    if !empty(lcorder)
      on error lnerr=error()
      set order to &lcorder
      on error &lconerr
    endif
    do case
      case llexcl
        if "EXCL" $ upper(sys(2011))
          select (lcworkarea)
          return lnerr=0
        else
          use in (lcalias)
        endif
      case !llexcl
        if "EXCL" $ upper(sys(2011))
          use in (lcalias)
        else
          select (lcworkarea)
          return lnerr=0
        endif
      otherwise
        return .f.
    endcase
  endif
  lcclause=iif(!empty(lcorder),"ORDER "+lcorder,"")+" "+;
           iif(!empty(lcalias),"ALIAS "+lcalias,"")+" "+;
           lcexcl
  on error lnerr=error()
  use (lfdbf) &lcclause in 0
  on error &lconerr
  select (lcworkarea)
return lnerr=0


#if .f.
procedure opnfil
parameters lfdbf, lcorder, lcalias, llexcl
private lfdbf, lcorder, lcalias, llexcl, lcexcl, lnerr, lconerr, lcclause
  lnerr=0
  lconerr=on("ERROR")
  lcworkarea=alias()
  do case
    case type("LFDBF")!="C"
      return .f.
    case !file(chgext(lfdbf,"DBF"))
      return .f.
  endcase
  if type("LCORDER")!="C"
    lcorder=""
  endif
  if type("LCALIAS")!="C" or empty(lcalias)
    lcalias=stem(noext(lfdbf))
  endif
  lcorder=trim(lcorder)
  lcalias=trim(lcalias)
  lcexcl=iif(llexcl,"EXCLUSIVE","")
  if used(lcalias)
    select (lcalias)
    on error lnerr=error()
    set order to &lcorder
    on error &lconerr
    if !empty(lcworkarea)
      select (lcworkarea)
    else
      select 0
    endif
    do case
      case llexcl and "EXCL" $ upper(sys(2011))
        return lnerr=0
      case !llexcl
        return lnerr=0
      otherwise
        return .f.
    endcase
  endif
  lcclause=iif(!empty(lcorder),"ORDER "+lcorder,"")+" "+;
           iif(!empty(lcalias),"ALIAS "+lcalias,"")+" "+;
           lcexcl
  on error lnerr=error()
  use (lfdbf) &lcclause in 0
  on error &lconerr
return lnerr=0
#endif
*ATAGS(@<array>[,<alias>])
*
*Places the list of tags into <array>.  Defaults to the
*current workarea.  If <alias> is sent then that alias
*is checked.
*
procedure atags
parameters latags, lcworkarea
private latags, lcworkarea, lcalias, lncnt1
  if type("LATAGS(1)")="U"
    return .f.
  endif
  lcalias=alias()
  do case
    case type("LCWORKAREA")="N"
      lcworkarea=iif(between(lcworkarea,0,select(1)),alias(lcworkarea),"")
    case type("LCWORKAREA")!="C"
      lcworkarea=lcalias
  endcase
  do case
    case used(lcworkarea)
      select (lcworkarea)
    case empty(alias())
      wait window "No Database in use!" nowait
      return .f.
    otherwise
      wait window "Alias not found!" nowait
      return .f.
  endcase
  if empty(cdx(1))
    return .f.
  endif
  dimension latags(1,2)
  latags=""
  lncnt1=1
  do while !empty(tag(lncnt1))
    dimension latags(lncnt1,2)
    latags(lncnt1,1)=tag(lncnt1)
    latags(lncnt1,2)=key(lncnt1)
    lncnt1=lncnt1+1
  enddo
  if !empty(lcalias)
    select (lcalias)
  else
    select 0
  endif
return

*AMOVE(@<source array>,@<destination array>,<src row>[,<dest row>])
*
*Moves <src row> from <source array> into <dest row> in <destination
*array>.  if <dest row> isn't sent the defualt <dest row> is the bottom
*of <destination array>.  Mainly used for text based arrays.
*
procedure amove
parameters lasrc,ladst, lnmovrow, lninsrow
private lasrc, ladst, lnmovrow, lndrows, lndcols, lnsrows, lnscols, lncnt1
  if type("LASRC(1)")="U" and type("LADST(1)")="U"
    wait window "Need two arrays!" nowait
    return .f.
  endif
  if type("LNMOVROW")!="N"
    lnmovrow=1
  endif
  if type("LNINSROW")!="N"
    lninsrow=alen(ladst,1)+1
  endif
  lndrows=alen(ladst,1)
  lndcols=alen(ladst,2)
  lnsrows=alen(lasrc,1)
  lnscols=alen(lasrc,2)
  lndrows=lndrows+1
  if lndcols=0
    dimension ladst(lndrows)
  else
    dimension ladst(lndrows,lndcols)
  endif
  =ains(ladst,lninsrow)
  do case
    case lnscols=0 and lndcols=0
      ladst(lninsrow)=lasrc(lnmovrow)
    case lnscols=0
      ladst(lninsrow,1)=lasrc(lnmovrow)
    case lndcols=0
      ladst(lninsrow)=lasrc(lnmovrow,1)
    otherwise
      for lncnt1=1 to lnscols
        if lncnt1 > lndcols
          exit
        endif
        ladst(lninsrow,lncnt1)=lasrc(lnmovrow,lncnt1)
      endfor
  endcase
  =adel(lasrc,lnmovrow)
  if lnsrows=1
    lasrc=""
  else
    if lnscols=0
      dimension lasrc(lnsrows-1)
    else
      dimension lasrc(lnsrows-1,lnscols)
    endif
  endif
return .t.


* EDITMEMO(<field>[,<title>][,<modifiable>][,<font>][,<fontsize>])
*
* this procedure may need to be fixed to handle memo fields, variables,
* or memvars
*
procedure editmemo
parameters lcfld, lctitle, lleditable, lcfont, lnfontsize
private lcfld, lcreadonly, lnselect, lnerr, lleditable, lcfont, lnfontsize
  push key clear
  if type("LCFLD")#"C" or empty(lcfld)
    pop key
    return .f.
  endif
  if type("LCTITLE")#"C" or empty(lcfld)
    lctitle=lcfld
  endif
  lctitle=lctitle+" (F10 to finish)"
  if type("LLEDITABLE")#"L"
    lleditable=.f.
  endif
  if type("LCFONT")#"C" or empty(lcfont)
    lcfont=wfont(1)
  endif
  if type("LNFONTSIZE")#"N" or empty(lnfontsize)
    lnfontsize=wfont(2)
  endif
  
  lcinwin=iif(empty(wontop())," IN SCREEN"," IN WINDOW "+wontop())
  lcwinname=sys(2015)
  lnselect=select()
  select 0
  create cursor text (&lcfld m)
  append blank
  gather memvar memo
  on key label f10 keyboard "{CTRL+W}" plain
  define window (lcwinname);
    from 0,0 to wrows(wontop())-3,wcols(wontop())-3;
    color scheme 10;
    float grow close zoom system &lcinwin;
    title lctitle;
    font lcfont, lnfontsize
  move window (lcwinname) center
  lcreadonly=iif(lleditable,"","NOEDIT")
  modify memo &lcfld window (lcwinname) &lcreadonly
  release window (lcwinname)
  scatter memvar memo
  use
  select (lnselect)
  pop key
return
*FLASHWIN(<flashes>, <delay>)
*
*(for windows version only)
*flashes the current window.  <flashes> is the number of flash.  <delay>
*is the delay between each flash.
*
procedure flashwin
parameter lnflashes, lndelay
private lnflashes, lndelay, llkeep, lnwait, getfocus, flashwindow, hwind, x
external procedure regfn
external procedure callfn
external library foxtools
  if type("_WINDOWS")#"L" or !_windows
    return .f.
  endif
  if type("LNFLASHES")!="N"
    lnflashes=3
  endif
  if type("LNDELAY")!="N"
    lndelay=.5
  endif
  llkeep="FOXTOOLS" $ set("LIBRARY")
  if loadlib("FOXTOOLS",.t.)
    getfocus=regfn("GetFocus","","I","USER.DLL")
    flashwindow=regfn("FlashWindow","II","I","USER.DLL")
    hwind=callfn(getfocus)
    for x=1 to (lnflashes*2) + 1
      =callfn(flashwindow,hwind,iif(mod(x,2)=0,0,1))
      lnwait=seconds()+lndelay
      do while seconds() < lnwait
      enddo
    endfor
  else
    return .f.
  endif
  =llkeep or killlib("FOXTOOLS")
  if .f.
    set library to foxtools
  endif
return

#if .f.
  if !loadlib("c:\fox\libs26\FOXTOOLS")
    wait window "cant load necessary library" nowait
    return .f.
  endif
  getfocus=regfn("GetFocus","","I","USER.DLL")
  getactivewindow=regfn("GetActiveWindow","","I","USER.DLL")
  closewindow=regfn("closewindow","I","","USER.DLL")
  findwindow=regfn("FindWindow","@C@C","I","USER.DLL")
  flashwindow=regfn("FlashWindow","II","I","USER.DLL")
  lcclass=""
  lcwindow="Command"
  define window sex title "FUCKME" from 1,1 to 10,50 system float;
    grow zoom minimize color scheme 10
  acti wind sex
  *hcommand=callfn(GetActiveWindow)
  hcommand=callfn(getfocus)
  ?hcommand
  for x=1 to 10
    =callfn(flashwindow,hcommand,iif(mod(x,2)=0,0,1))
    for y=1 to 300000
    endfor
  endfor
  =callfn(closewindow,hcommand)
#endif

* VALDTE([<expd>])
*
* returns a valid date for <expd>
*
procedure valdte
parameters lddate
private lddate
  do case
    case type("lddate")="C"
      if at("/",lddate)=0
        lddate=transform(lddate,"@R 99/99/99")
      endif
      lddate=ctod(lddate)
    case type("lddate")!="D"
      lddate=date()
  endcase
return lddate

* BINASC(<expc>)
*
* BINARY TO ASCII CONVERSION with a binary-like character
* string <expc> sent as a parameter.
*
procedure binasc
parameter lcbinary
private lncnt1, lnasc, lcbinary
  if type("LCBINARY")!="C"
    return ""
  endif
  lnasc=0
  lcbinary=padl(lcbinary,8,"0")
*  lnasc=asc(substr(lcascii,1,1))
  for lncnt1=1 to 8
    lnasc=lnasc+iif(substr(lcbinary,lncnt1,1)="1",2^(8-lncnt1),0)
  endfor
  lcascii=chr(lnasc)
return lcascii

* ASTATES(<array>)
*
* puts a list of us states and territories into <array>
*
procedure astates
parameters lasrc
  if type("LASRC(1)")="U"
    return .f.
  endif
  dimension lasrc(52,2)
  lasrc(1,1)="AL"
  lasrc(1,2)=[Alabama]
  lasrc(2,1)="AK"
  lasrc(2,2)=[Alaska]
  lasrc(3,1)="AZ"
  lasrc(3,2)=[Arizona]
  lasrc(4,1)="AR"
  lasrc(4,2)=[Arkansas]
  lasrc(5,1)="CA"
  lasrc(5,2)=[California]
  lasrc(6,1)="CN"
  lasrc(6,2)=[Canada]
  lasrc(7,1)="CO"
  lasrc(7,2)=[Colorado]
  lasrc(8,1)="CT"
  lasrc(8,2)=[Connecticut]
  lasrc(9,1)="DE"
  lasrc(9,2)=[Delaware]
  lasrc(10,1)="FL"
  lasrc(10,2)=[Florida]
  lasrc(11,1)="GA"
  lasrc(11,2)=[Georgia]
  lasrc(12,1)="HI"
  lasrc(12,2)=[Hawaii]
  lasrc(13,1)="ID"
  lasrc(13,2)=[Idaho]
  lasrc(14,1)="IL"
  lasrc(14,2)=[Illinois]
  lasrc(15,1)="IN"
  lasrc(15,2)=[Indiana]
  lasrc(16,1)="IA"
  lasrc(16,2)=[Iowa]
  lasrc(17,1)="KS"
  lasrc(17,2)=[Kansas]
  lasrc(18,1)="KY"
  lasrc(18,2)=[Kentucky]
  lasrc(19,1)="LA"
  lasrc(19,2)=[Louisiana]
  lasrc(20,1)="ME"
  lasrc(20,2)=[Maine]
  lasrc(21,1)="MD"
  lasrc(21,2)=[Maryland]
  lasrc(22,1)="MA"
  lasrc(22,2)=[Massachusetts]
  lasrc(23,1)="MI"
  lasrc(23,2)=[Michigan]
  lasrc(24,1)="MN"
  lasrc(24,2)=[Minnesota]
  lasrc(25,1)="MS"
  lasrc(25,2)=[Mississippi]
  lasrc(26,1)="MO"
  lasrc(26,2)=[Missouri]
  lasrc(27,1)="MT"
  lasrc(27,2)=[Montana]
  lasrc(28,1)="NE"
  lasrc(28,2)=[Nebraska]
  lasrc(29,1)="NV"
  lasrc(29,2)=[Nevada]
  lasrc(30,1)="NH"
  lasrc(30,2)=[New Hampshire]
  lasrc(31,1)="NJ"
  lasrc(31,2)=[New Jersey]
  lasrc(32,1)="NM"
  lasrc(32,2)=[New Mexico]
  lasrc(33,1)="NY"
  lasrc(33,2)=[New York]
  lasrc(34,1)="NC"
  lasrc(34,2)=[North Carolina]
  lasrc(35,1)="ND"
  lasrc(35,2)=[North Dakota]
  lasrc(36,1)="OH"
  lasrc(36,2)=[Ohio]
  lasrc(37,1)="OK"
  lasrc(37,2)=[Oklahoma]
  lasrc(38,1)="OR"
  lasrc(38,2)=[Oregon]
  lasrc(39,1)="PA"
  lasrc(39,2)=[Pennsylvania]
  lasrc(40,1)="PR"
  lasrc(40,2)=[Puerto Rico]
  lasrc(41,1)="RI"
  lasrc(41,2)=[Rhode Island]
  lasrc(42,1)="SC"
  lasrc(42,2)=[South Carolina]
  lasrc(43,1)="SD"
  lasrc(43,2)=[South Dakota]
  lasrc(44,1)="TN"
  lasrc(44,2)=[Tennessee]
  lasrc(45,1)="TX"
  lasrc(45,2)=[Texas]
  lasrc(46,1)="UT"
  lasrc(46,2)=[Utah]
  lasrc(47,1)="VT"
  lasrc(47,2)=[Vermont]
  lasrc(48,1)="VA"
  lasrc(48,2)=[Virginia]
  lasrc(49,1)="WA"
  lasrc(49,2)=[Washington]
  lasrc(50,1)="WV"
  lasrc(50,2)=[West Virginia]
  lasrc(51,1)="WI"
  lasrc(51,2)=[Wisconsin]
  lasrc(52,1)="WY"
  lasrc(52,2)=[Wyoming]
return
* POPINFO(<data>[,<itemnum>][,<delimiter>])
*
* Extracts item <itemnum> from string <data> that is
* delimited by <delimiter>.  Defualt item is 1.  Default
* delimiter is ",".  returns result of "pop".  Also 
* deletes the item from the string if the string is 
* passed by reference.  
*
procedure popinfo
parameter lcinfoline, lnitem, lcdelim
private lcinfoline, lnitem, lnitmcnt, lcinfo, lcdelim
  if type("LCINFOLINE")!="C"
    return ""
  endif
  if type("LNITEM")!="N" or lnitem < 1
    lnitem=1
  endif
  if type("LCDELIM")!="C"
    lcdelim=","
  endif
  lnitmcnt=occurs(lcdelim,lcinfoline)+1
  if !between(lnitem,1,lnitmcnt)
    return ""
  endif
  do case
    case at(lcdelim,lcinfoline)=0
      lcinfo=lcinfoline
      lcinfoline=""
    case lnitem=lnitmcnt
      lcinfo=substr(lcinfoline,rat(lcdelim,lcinfoline)+1)
      lcinfoline=substr(lcinfoline,1,rat(lcdelim,lcinfoline)-1)
    otherwise
*      set step on
      lcinfo=left(lcinfoline,at(lcdelim,lcinfoline,lnitem)-1)
      if lnitem=1
        lcinfoline=substr(lcinfoline, at(lcdelim,lcinfoline,lnitem)+1)
      else
*        lcinfoline=substr(left(lcinfoline,at(lcdelim,lcinfoline,lnitem)-1),rat(lcdelim,lcinfo)+1)+;
                   substr(lcinfoline,at(lcdelim,lcinfoline,lnitem)+1)
        lcinfoline=substr(lcinfoline,1,at(lcdelim,lcinfoline,lnitem-1))+;
                   substr(lcinfoline,at(lcdelim,lcinfoline,lnitem)+1)
      endif
      lcinfo=substr(lcinfo,rat(lcdelim,lcinfo)+1)
  endcase    
*  lcinfo=alltrim(lcinfo)
return lcinfoline

* NYEAR(<date>)
*
* returns next year date
*
procedure nyear
parameters lddate
private lddate
  do case
    case type("lddate")="C"
      if at("/",lddate)=0
        lddate=transform(lddate,"@R 99/99/99")
      endif
      lddate=ctod(lddate)
    case type("lddate")!="D"
      lddate=date()
  endcase
  lddate=ctod(left(dtoc(lddate),6)+right(str(year(lddate)+1,4),2))
return lddate

* CDXALL()
*
* Indexes on all fields for file.  Not finished.
*
procedure cdxall
parameters lcfile, lcfld
private lnloop
  if type("LCFILE")!="C"
    lcfile=dbf()
  endif
  if used(lcfile)
    select (lcfile)
  endif
  use (lcfile) exclusive
  for lnloop=1 to fcount()
    if type(field(lnloop))="M"
      loop
    endif
    wait window "Indexing "+lcfile+" on "+field(lnloop) nowait
    lcfld=field(lnloop)
    index on &lcfld tag &lcfld
  endfor
  wait clear
return

* EOM([<date>])
*
* returns end of month of <date>
*
procedure eom
parameters lddate
private lddate
  do case
    case type("lddate")="C"
      if at("/",lddate)=0
        lddate=transform(lddate,"@R 99/99/99")
      endif
      lddate=ctod(lddate)
    case type("lddate")!="D"
      lddate=date()
  endcase
  lddate=gomonth(ctod(stuff(dtoc(lddate),4,2,"01")),1)-1
return lddate

* _USEALL
*
* uses all dbfs in default directory.
* calls ALERTMSG()
*
procedure _useall
private lndbfs, ladir, lconerr, lnerr
  lnerr=0
  lndbfs=adir(ladir,"*.DBF")
  =asort(ladir)
  for lncnt1=1 to lndbfs
    lconerr=on("ERROR")
    on error lnerr=error()
    if !used(noext(stem(ladir(lncnt1,1))))
      select 0
      use &ladir(lncnt1,1)
      if lnerr # 0
        =alertmsg(message(),"Error opening "+ladir(lncnt1,1))
      endif
    endif
  endfor
return
* FINDINFO(<item>, <data> [,<delimiter>])
*
* returns position of <item> in <data> line delimited by <delimiter>.
*
procedure findinfo
parameters lcinfo, lcinfoline, lcdelim
private lcinfoline, lnitmcnt, lcinfo, lcdelim, lnpos
  if type("LCINFO")!="C" or empty(lcinfo)
    return 0
  endif
  if type("LCINFOLINE")!="C" or empty(lcinfoline)
    return 0
  endif
  if type("LCDELIM")!="C" or len(lcdelim)=0
    lcdelim=","
  endif
  lcinfo=alltrim(lcinfo)
  lcinfoline=alltrim(lcinfoline)
  if right(lcinfoline,1)=lcdelim
    lcinfoline=left(lcinfoline,len(lcinfoline)-1)
  endif
  lnpos=at(lcinfo,lcinfoline)
  if lnpos=0
    return 0
  endif
  lnitmcnt=occurs(lcdelim,left(lcinfoline,lnpos))+1
  if getinfo(lcinfoline,lnitmcnt,lcdelim)!=lcinfo
    lnitmcnt=0
  endif
return lnitmcnt


*DLGBOX(<message>,<title>[,<button1>[,<button2>[,<button3>[,<button4>]]]])
*
*displays a dialog box with <message> as the text and <title> and the title.
*<buttonx> are the text on the buttons.  returns the number of the button
*pressed, 0 if cancelled or -1 if no message was sent.
*
procedure dlgbox
parameters lcmsg, lctitle, lbtxt1, lbtxt2, lbtxt3, lbtxt4
private lcmsg, lctitle, lbtxt1, lbtxt2, lbtxt3, lbtxt4
private lnsetmemo, lnmaxsiz, lcbutton, lnbutcnt, lnspc, lnbutcol, lncnt1,;
        lbkey1, lbkey2, lbkey3, lbkey4, lctxtvar, lntxtpos, lcwintype
  if type("LCMSG")#"C"
    return -1
  endif
  if type("LCTITLE")#"C"
    lctitle="System Message"
  endif
  lnsetmemo=set("MEMOWIDTH")
  set memowidth to 40
  lcmsg=alltrim(lcmsg)
  lnlines=memlines(lcmsg)
  do case
    case _dos
      lcwintype="DOUBLE"
      lnbutht=1
    otherwise
      lcwintype="SYSTEM"
      lnbutht=1.75
  endcase
  define window wdlgbox;
        at 0,0 size lnlines+4,42;
        &lcwintype;
        float;
        noclose;
        nogrow;
        nominimize;
        nozoom;
        title lctitle;
        color scheme 7
  move window wdlgbox center
  activate window wdlgbox noshow
  lcans=0
  lbtxt1=iif(type("LBTXT1")="C",lbtxt1,"OK")
  lbtxt2=iif(type("LBTXT2")="C",lbtxt2,"")
  lbtxt3=iif(type("LBTXT3")="C",lbtxt3,"")
  lbtxt4=iif(type("LBTXT4")="C",lbtxt4,"")
  lnmaxsiz=0
  lcbutton="*h "
  lnbutcnt=0
  for lncnt1=1 to 4
    lctxtvar="LBTXT"+str(lncnt1,1)
    lctmp=strtran(strtran(strtran(evaluate(lctxtvar),"\<"),"\!"),"\?")
    lnmaxsiz=iif(len(lctmp)>lnmaxsiz,len(lctmp),lnmaxsiz)
    if !empty(evaluate(lctxtvar))
      if ! "\<" $ evaluate(lctxtvar)
        lntxtpos=rat("\",evaluate(lctxtvar))
        if lntxtpos=0
          store "\<"+evaluate(lctxtvar) to (lctxtvar)
        else
          store stuff(evaluate(lctxtvar),lntxtpos+2,0,"\<") to (lctxtvar)
        endif
      endif
      lcbutton=lcbutton+evaluate(lctxtvar)+";"
      lnbutcnt=lnbutcnt+1
    endif
  endfor
  lcbutton=left(lcbutton,len(lcbutton)-1)
  lnspc=int((wcol()-2-(lnmaxsiz*lnbutcnt))/(lnbutcnt))
  lnbutcol=(wcol()-2-lnspc*(lnbutcnt-1)-(lnmaxsiz*lnbutcnt))/2
  for lncnt1=1 to lnlines
    @ lncnt1,0 say padc(alltrim(mline(lcmsg,lncnt1)),wcol())
  endfor
  @lnlines+2,lnbutcol get lcans function lcbutton size lnbutht,lnmaxsiz,lnspc
  read cycle modal
  deactivate window wdlgbox
  release window wdlgbox
  set memowidth to lnsetmemo
return lcans

* BROWSEEK([<expc1>[,<expc2>[,<expc3>]]])
*
* to be called from a browse, performs a seek on browse
* in window <expc1> on field <expc2> and executes
* <expc3> when enter is pressed.
*
procedure browseek
parameters lcbrow, lcfield, lccmd
private lcbrow, lcfield, lccmd, lccursor, lnrecno, lnstart, lcserch, lnchar,;
        lnlapse, lnskip
  push key clear
  if type("LCBROW")!="C"
    lcbrow=wontop()
  endif
  if type("LCFIELD")!="C"
    lcfield=key()
  endif
  if type("LCCMD")!="C"
    lccmd="exit"
  endif
  if type("EVALUATE(LCFIELD)")!="C"
    wait window "Can't speed scroll" nowait
    pop key
    return
  endif
  wait window "SPEED SCROLL ON" nowait
  lccursor=set("cursor")
  lnrecno=recno()
  show window (lcbrow) refresh same
  lnstart=seconds()
  lcserch=""
  lnchar=0
  set cursor off
  do while .t.
    lnlapse=seconds()-lnstart
    lnchar=inkey(.1)
    if lnchar != 0
      do case
        case lnchar=-9                              && f10
          exit
        case lnchar=3                               && pgdn
          lnskip=wrows(lcbrow)-4
          skip lnskip
          if eof()
            go bottom
          endif
          lcserch=&lcfield
        case lnchar=5                               && up
          if !bof()
            skip -1
          endif
          if bof()
            go top
          endif
          lcserch=&lcfield
        case lnchar=7                               && delete
          lcserch=""
        case lnchar=13                              && enter
          if !empty(lccmd)
            &lccmd
          endif
        case lnchar=18                              && pgup
          lnskip=(wrows(lcbrow)-4) * -1
          skip lnskip
          if bof()
            go top
          endif
          lcserch=&lcfield
        case lnchar=24                              && down
          if !eof()
            skip 1
          endif
          if eof()
            go bottom
          endif
          lcserch=&lcfield
        case lnchar=27                              && escape
          exit
*        case lnchar=32                              && space
*          lcserch=""
*        case between(lnchar,33,126)                 && alpha
        case between(lnchar,32,126)                 && alpha
          if len(lcserch)<len(&lcfield)
            lcserch=lcserch+chr(lnchar)
          endif
        case lnchar=127                             && backspace
          if len(lcserch)>0
            lcserch=left(lcserch,len(lcserch)-1)
          endif
      endcase
      lnstart=seconds()
*      lcserch=trim(lcserch)
      seek lcserch
      wait window lcserch nowait
      lnrecno=recno()
      show window (lcbrow) refresh same
    endif
  enddo
  wait window "SPEED SCROLL OFF" nowait
  set cursor &lccursor
  pop key
return


* YESNO(<message>[,<title>[,<cancelbut>]])
*
* displays a yes no dialog window.  returns -1 if
* cancelled, 0 if no, and 1 if yes.  <message> is the
* message displayed.  <title> is the title of the
* dialog window.  if <cancelbut> is .t.,
* places a cancel button as an option.
* will attempt to load FOXTOOLS.FLL if available.
* calls LOADLIB(), DLGBOX() or MSGBOX(), KILLLIB()
*
procedure yesno
parameters lcmsg, lctitle, llcanc
private lcmsg, lctitle, llcanc, llkeep
  if type("LCMSG")!="C" or empty(lcmsg)
    lcmsg="Are you sure?"
  endif
  if type("LCTITLE")!="C" or empty(lctitle)
    lctitle="System"
  endif
  llkeep="FOXTOOLS" $ set("LIBRARY")
  if loadlib("FOXTOOLS",.t.)
    lnreturn=msgbox(lcmsg,lctitle, iif(llcanc,35,36))
    do case
      case lnreturn=2
        lnreturn=-1
      case lnreturn=6
        lnreturn=1
      case lnreturn=7
        lnreturn=0
    endcase
  else
    lnreturn=dlgbox(lcmsg,lctitle,"Yes","No",iif(llcanc,"Cancel",""))
    do case
      case lnreturn=2
        lnreturn=0
      case lnreturn=3 or lnreturn=0
        lnreturn=-1
    endcase
  endif
  =llkeep or killlib("FOXTOOLS")
  if .f.
    set library to foxtools
  endif
return lnreturn

* _CONFIG([<configfp>])
*
* set environment according to <configfp>'s configuration
* SYS(2019) is the default.
*
procedure _config
parameters lfconfig
private lfconfig, lfcurs, lnselect, lnerr, lconerr, lnlines, lnloop, lnsetmemw
  if type("LFCONFIG")!="C"
    lfconfig=sys(2019)
  endif
  if empty(lfconfig) or !file(lfconfig)
    return .f.
  endif
  lnselect=select()
  lfcurs=sys(2015)
  lnerr=0
  lconerr=on("ERROR")
  on error lnerr=error()
  create cursor (lfcurs) (config m)
  if lnerr # 0
    wait window "Couldn't create cursor." nowait
    on error &lconerr
    select (lnselect)
    return .f.
  endif
  append blank
  append memo config from (lfconfig)
  if lnerr # 0
    wait window "Couldn't load "+lfconfig+"." nowait
    on error &lconerr
    select (lnselect)
    return .f.
  endif

  lnsetmemw=set("MEMOWIDTH")
  set memowidth to 256
  lnlines=memlines(config)

  for lnloop=1 to lnlines
    if empty(mline(config,lnloop)) or left(mline(config,lnloop),1)="*"
      loop
    endif
    wait window lfconfig+" Processing Line "+ltrim(str(lnloop))+"..." nowait
    lcset=alltrim(substr(mline(config,lnloop),1,at("=",mline(config,lnloop))-1))
    lcval=alltrim(substr(mline(config,lnloop),at("=",mline(config,lnloop))+1))
    if empty(lcset) or left(lcset,1)="*"
      loop
    endif
    if left(lcset,1)="_"
      store &lcval to (lcset)
    else
      set &lcset &lcval
      if lnerr # 0
        lnerr=0
        set &lcset to &lcval
      endif
      if lnerr # 0
        lnerr=0
      endif
    endif
  endfor
  on error &lconerr
  set memowidth to lnsetmemw
  use
  select (lnselect)
  wait window "Done!" nowait
return

* BLDDICT(<dictionary>,<tableid>,<file>)
*   dictionary <expc>= data dictionary filename
*   tableid <expc>= table id
*   file <expc>= filename of table to insert
*
* Calls APPBLANK.PRG
*
procedure blddict
parameters lfdict, lctable, lffile
private lfdict, lctable, lffile, lftmp1, lftmp2, lcalias, lnerr, lnselect,;
        lconerr
  lnselect=select()
  lcalias=alias()
  lftmp1="T~"+right(sys(3),6)
  lftmp2="T~"+right(sys(3),6)
  lnerr=0
  if type("LFDICT")!="C" or empty(lfdict)
    lfdict="DATADICT"
  endif
  do while !ispath(path(lfdict))
    lfdict=putfile("Data Dictionary filename",stem(lfdict),"DBF")
    if lastkey()=27
      wait window "Dictionary Update cancelled!" nowait
      return .f.
    endif
  enddo
  do while type("LFFILE")!="C" or !file(lffile)
    if !empty(lcalias)
      lffile=dbf()
      exit
    endif
    lffile=putfile("File to Add to Dictionary","","DBF")
    if lastkey()=27
      wait window "Dictionary Update cancelled!" nowait
      return .f.
    endif
  enddo
  if upper(noext(lffile))=upper(noext(lfdict))
    wait window "Cant include self in Data Dictionary!" nowait
    return .f.
  endif
  if empty(lcalias)
    select 0
    use (lffile)
    lcalias=alias()
  endif
  if type("LCTABLE")!="C" or empty(lctable)
    lctable=noext(stem(lffile))
  endif
  if used("A_DICT")
    use in a_dict
  endif

*\CORE! Thu  06-15-95  begin Moved from THIS SPOT
  select 0
  if !file(chgext(lfdict,"DBF"))
    create table (lfdict) (tablid c(8), field_name c(10), field_type c(1),;
                           field_len n(3), field_dec n(3))
  endif
  lconerr=on("ERROR")
  on error lnerr=error()
  use (lfdict) alias a_dict exclusive
  if lnerr # 0
    wait window message() nowait
    on error &lconerr
    select (lnselect)
    return .f.
  endif
  on error &lconerr
  if empty(cdx(1))
    index on tablid tag tablid
  endif
*\CORE! Thu  06-15-95  end

  select (lcalias)
  copy structure extended to (lftmp1)
  select 0
  create table (lftmp2) (tablid c(8), field_name c(10), field_type c(1),;
                         field_len n(3), field_dec n(3))
  append from (lftmp1)
  replace all tablid with lctable
  use (lftmp2) alias a_tmp2
  select 0

*\CORE! Thu  06-15-95  THIS SPOT
*  append from (lftmp2)
  select a_tmp2
  scan
    scatter memvar memo
    select a_dict
    locate for tablid=m.tablid and field_name=m.field_name
    if !found()
      =appblank("","tablid+field_name")
    endif
    gather memvar memo
    select a_tmp2
  endscan
  use in a_tmp2
  use in a_dict
  erase (lftmp1+".DBF")
  erase (lftmp2+".DBF")
*  select (lcalias)
  select (lnselect)
return .t.

* ACURS(@<array>)
*
* Moves the contents of <array> into a
* cursor.  Will have to rewrite some time.
* My version accepts
* single dimensional arrays and also handle type conflicts.
* Also uses unique cursor name so it can be called more
* than once and on multiple arrays.
*
procedure acurs
parameters lasrc
private lasrc, lncnt1, lncnt2, lcfldlst, lcctype, lnlen, lndec, lctemp, lnerr,;
        lconerr
  if type("LASRC(1)")="U"
    return .f.
  endif
  lnsrows= ALEN(lasrc,1)
  lnscols= ALEN(lasrc,2)
  lcfldlst= "("
  if lnscols=0
    lncnt1=1
    lcctype = type("LASRC[1]")
    do _acurs
  else
    for lncnt1= 1 to  lnscols
      lcctype = type("LASRC[1,LNCNT1]")
      do _acurs
    endfor
  endif
  lcfldlst= left(lcfldlst,len(lcfldlst)-2)+")"
  lnerr=0
  lconerr=on("ERROR")
  on error lnerr=error()
  create cursor sys(2015) &lcfldlst
  on error &lconerr
  if lnerr # 0
    wait window "Couldn't create cursor." nowait
    select (lnselect)
    return .f.
  endif
  if lnscols=0
    for lncnt1=1 to lnsrows
      append blank
      if type("LASRC[LNCNT1]")=type("COL_1")
        replace col_1 with lasrc[lncnt1]
      endif
    endfor
  else
    append from array lasrc
  endif
  go top
return .t.

procedure _acurs
  lndec=0
  do case
    case lcctype= "C"
      lnlen=len(trim(lasrc[1,lncnt1]))
      for lncnt2=1 to lnsrows
        if lnscols=0
          lnlen=iif(type("LASRC[LNCNT2]")!="C",lnlen,;
                     max(lnlen,len(trim(lasrc[lncnt2]))))
        else
          lnlen=iif(type("LASRC[LNCNT2,LNCNT1]")!="C",lnlen,;
                     max(lnlen,len(trim(lasrc[lncnt2,lncnt1]))))
        endif
      endfor
      lnlen=min(iif(lnlen=0,10,lnlen),254)
    case lcctype= "N" .or. lcctype= "F"
      lnlen= 10
      if "." $ str(lasrc[1,lncnt1])
        lctemp=alltrim(str(lasrc[1,lncnt1]))
        lndec=len(lctemp)-at(".",lctemp)
      endif
    case lcctype= "L"
      lnlen= 1
    case lcctype= "D"
      lnlen= 8
    otherwise
      lnlen= 10
  endcase
  lcfldlst=lcfldlst+"col_"+alltrim(str(lncnt1,3))+" "+lcctype
  lcfldlst=lcfldlst+"("+alltrim(str(lnlen))
  if lndec<> 0
     lcfldlst=lcfldlst+","+alltrim(str(lndec))
  endif
  lcfldlst=lcfldlst+"), "
return

* EXT(<filename>)
*
* Returns the extension of <filename>.
*
procedure ext
parameters lcfile
private lcfile, lcext
  if type("LCFILE")!="C" or occurs(".",lcfile)!=1
    return ""
  endif
  lcext=substr(lcfile,at(".",lcfile)+1)
return upper(lcext)


* _STRUCTS()
*
* lists structures of open tables to file _structs.txt and displays it
*
procedure _structs
  lcsetprint=set("PRINTER",1)
  set printer to _structs.txt
  *set printer on
  lnareas=select(1)
  for x=1 to lnareas
    select (x)
    if !empty(alias())
      list structure to printer
    endif
  endfor
  *set printer off
  set printer to &lcsetprint
  modify command _structs.txt
return

* _MEMORY()
*
* lists memory to file and displays it.
*
procedure _memory
private lftmp1
  lftmp1="~"+right(sys(3),7)+".TXT"
  lcwind=sys(2015)
  list memory to file (lftmp1) noconsole
  define window (lcwind);
    title "This is your memory";
    at 0,0 size 1,1 ;
    float grow zoom system
  if _windows
    modify window (lcwind) zoom
  else
    zoom window (lcwind) max
  endif
  modify command (lftmp1)
  release window (lcwind)
  erase (lftmp1)
return

* _LIST([<what>])
*
* lists information specified by <what> which may be one
* of MEMORY, STRUCTURE, STATUS, FILE.
*
procedure _list
parameters lcparm
private lcparm, lftmp1
  if type("LCPARM")!="C" or;
     !inlist(upper(left(lcparm,4)),"STRU","STAT","MEMO","FILE")
    lcparm="STATUS"
  endif
  lftmp1="~"+right(sys(3),7)+".TXT"
  lcwind=sys(2015)
  list &lcparm to file (lftmp1) noconsole
  define window (lcwind);
    title "Here is your dump";
    at 0,0 size 1,1 ;
    float grow zoom system
  if _windows
    modify window (lcwind) zoom
  else
    zoom window (lcwind) max
  endif
  modify command (lftmp1)
  release window (lcwind)
  erase (lftmp1)
return
* KILLLIB(<library>)
*
* Removes <library> from memory.
*
procedure killlib
parameters lflib
private lflib, lclibs, lncnt1, lflibrel
  if type("LFLIB")!="C" or empty(lflib)
    return .f.
  endif
  lncnt1=1
  lflib=upper(lflib)
  do case
    case _windows
      lflib=chgext(lflib,"FLL")
    case _dos
      lflib=chgext(lflib,"PLB")
    otherwise
      return .f.
  endcase
  if !upper(lflib) $ set("LIBRARY")
    return .t.
  endif
  lclibs=set("LIBRARY")
  do while !empty(getinfo(lclibs,lncnt1))
    lflibrel=getinfo(lclibs,lncnt1)
    if lflib $ lflibrel
      release library (lflibrel)
    endif
    lncnt1=lncnt1+1
  enddo
return .t.

procedure perctile
parameters lnitem, lntotal, lnpart
  if type("LNITEM")!="N"
    lnitem=0
  endif
  if type("LNTOTAL")!="N"
    lntotal=-1
  endif
  if type("LNPART")!="N"
    lnpart=4
  endif
return round(lnpart*((lnitem+1)/lntotal),0)

* ACODE(@<array>,<arrayname>)
*
* this generates source code to define an array
* <arrayname> is the name given to the array in the code
*
procedure acode
  parameters lasrc, lcname
  private lasrc, lnsrows, lnscols, lncnt1, lncnt2, lcelem, lcname, lnselect,;
          lftmp1
  if type("LCNAME")!="C"
    lcname=sys(2015)
  endif
  if type("LASRC(1)")="U"
    wait window "Not an array!" nowait
    return
  endif
  lftmp1=sys(2015)
  lnselect=select()
  lnsrows=alen(lasrc,1)
  lnscols=alen(lasrc,2)
  lcline=""
  select 0
  create cursor (lftmp1) (code m)
  append blank
  if lnscols=0
    replace code with "dimension "+lcname+"("+alltrim(str(lnsrows))+;
                      ")" + chr(13)
  else
    replace code with "dimension "+lcname+"("+alltrim(str(lnsrows))+;
                      ","+alltrim(str(lnscols))+")" + chr(13)
  endif
  for lncnt1= 1 to lnsrows
    if lnscols=0
      lcelem=lcname+"("+alltrim(str(lncnt1))+")"
      do _acode
    endif
    for lncnt2= 1 to lnscols
      lcelem=lcname+"("+alltrim(str(lncnt1))+","+alltrim(str(lncnt2))+")"
      do _acode
    endfor
  endfor
  modify memo code in screen nowait
*  use
  select (lnselect)
return

procedure _acode
  do case
    case type("LASRC(lncnt1,lncnt2)")="C"
      lcline=lcelem+[="]+trim(lasrc(lncnt1,lncnt2))+["]
    case type("LASRC(lncnt1,lncnt2)")$"NF"
      lcline=lcelem+"="+alltrim(str(lasrc(lncnt1,lncnt2)))
    case type("LASRC(lncnt1,lncnt2)")="D"
      lcline=lcelem+"={"+dtoc(lasrc(lncnt1,lncnt2))+"}"
    case type("LASRC(lncnt1,lncnt2)")="L"
      lcline=lcelem+"="+iif(lasrc(lncnt1,lncnt2),".t.",".f.")
  endcase
  replace code with lcline+chr(13) additive
return

* LOADLIB(<library>[,<additive>])
*
* Load <library> into memory.  If <additive> is .t.,
* the library is loaded with the additive clause.
*
procedure loadlib
parameters lflib, lladditive
private lflib, lladditive, lcadditive
  if type("LFLIB")!="C" or empty(lflib)
    return .f.
  endif
  if type("LLADDITIVE")!="L"
    lladditive=.f.
  endif
  if !"." $ lflib
    do case
      case _windows
        lflib=chgext(lflib,"FLL")
      case _dos
        lflib=chgext(lflib,"PLB")
      otherwise
        return .f.
    endcase
  endif
  if !file(lflib)
    return .f.
  endif
  if upper(lflib) $ set("LIBRARY")
    return .t.
  endif
  lcadditive=iif(lladditive,"ADDITIVE","")
  set library to (lflib) &lcadditive
return .t.

* _OPNPJX
*
* opens all projects in default directory
*
procedure _opnpjx
parameter llpause
private x, lconesc, lcsetesc, llpause, lcnowait
  =adir(lapjx,"*.PJX")
  lconesc=on("ESCAPE")
  lcsetesc=set("ESCAPE")
  on escape exit
  lcnowait=iif(type("LLPAUSE")="L" and llpause,"","NOWAIT")
  for x=1 to alen(lapjx,1)
    modi proj (lapjx(x,1)) &lcnowait
    if lastkey()=27
      exit
    endif
  endfor
  on escape &lconesc
  set escape &lcsetesc
return

* _ZIPPJX
*
* project zips all projects in default directory
*
procedure _zippjx
parameter llcomp
private x, lconesc, lcsetesc
  =adir(lapjx,"*.PJX")
  lconesc=on("ESCAPE")
  lcsetesc=set("ESCAPE")
  on escape exit
  for x=1 to alen(lapjx,1)
    =projzip(lapjx(x,1),"",llcomp) 
  endfor
  on escape &lconesc
  set escape &lcsetesc
return

* RCLSFIL(<alias>)
*
* Registers file close of <alias> in array maintained by REGTAB.
*
* Calls NOEXT(), REGTAB()
*
procedure rclsfil
parameters lcalias
private lcalias, lnalen, lnstat
  if type("LCALIAS")!="C" or empty(lcalias)
    lcalias=alias()
  endif
  lcalias=upper(noext(lcalias))
  if !used(lcalias)
    return .t.
  endif
  if type("_REGTAB")="U"
    use in (lcalias)
  else
    lnstat=regtab("STATUS",lcalias)
    if lnstat > 0
      if lnstat=1
        use in (lcalias)
        =regtab("CLEAR",lcalias)
      else
        =regtab("CLOSE",lcalias)
      endif
    endif
  endif
return

* LOADVIEW(@<array>[,<arealist>])
* Sets up workareas according to <array>.  If <arealist> is
* sent, where <arealist> is a comma delimited string, then
* only those areas are reopened.
*
* The array structure should look like this:
*   LASRC(x,1)=ALIAS()
*   LASRC(x,2)=<filename>
*   LASRC(x,3)=ORDER()
*   LASRC(x,4)=RECNO()
*   LASRC(x,5)=<exclusive status>
*   LASRC(x,6)=SET("RELATION")
*   LASRC(x,7)=SET("FILTER")
*
* Calls SAVEVIEW(), GETINFO(), POPINFO()
*
procedure loadview
parameters lasrc, lcareas
private lasrc, lcareas, lnareas, lnlastarea, lncnt1, llviewopen, lnselect, latmp
  external array lasrc
  if type("lasrc(1)")="U"
    return .f.
  endif
  if type("LCAREAS")!="C"
    lcareas=""
  endif
  lnselect=select()
  lcalias=alias()
  lnareas=alen(lasrc,1) - 1
  if empty(lasrc(1))
    return
  endif
  dimension latmp(1)
  =saveview(@latmp,lcareas)
  if !empty(lcareas)
    for lncnt1=1 to 2
      lctmplin=lcareas
      do while !empty(getinfo(lctmplin,1))
        lcalias=upper(getinfo(lctmplin,1))
        lctmplin=popinfo(lctmplin)
        lncnt2=ascan(lasrc,lcalias)
        if lncnt2=0
          loop
        endif
        lncnt2=asubscript(lasrc,lncnt2,1)
        if lncnt1=1
          =_loadview1(lncnt2)
        else
          =_loadview3(lncnt2)
        endif
      enddo
    endfor
  else
    for lncnt1=1 to lnareas
      =_loadview1(lncnt1)
    endfor
    for lncnt1=1 to lnareas
      =_loadview3(lncnt1)
    endfor
  endif
  if used(lasrc(lnareas+1,1))
    select &lasrc(lnareas+1,1)
  else
    select 0
  endif
  return

procedure _loadview1
parameters lnitem
private lnitem
  if type("LNITEM")#"N"
    return .f.
  endif
  if !used(lasrc(lnitem,1))
    =_loadview2(lasrc(lnitem,2))
    select 0
    use &lasrc(lnitem,2) alias &lasrc(lnitem,1) &lasrc(lnitem,5)
  endif
  select &lasrc(lnitem,1)
  set order to &lasrc(lnitem,3)
  set relation to
  if between(lasrc(lnitem,4),1,reccount())
    goto lasrc(lnitem,4)
  endif
  return

procedure _loadview2
parameters lfdbf
private lfdbf, lnpos, lcalias
  if type("LFDBF")!="C"
    return .f.
  endif
  do while .t.
    lnpos=ascan(latmp, lfdbf)
    if lnpos=0
      exit
    endif
    lcalias=latmp(asubscript(latmp,lnpos,1),1)
    if used(lcalias)
      use in (lcalias)
    endif
    latmp(asubscript(latmp,lnpos,1),2)="*********"
  enddo
  return

procedure _loadview3
parameters lnitem
private lnitem
  if type("LNITEM")#"N"
    return .f.
  endif
  select &lasrc(lnitem,1)
  set relation to &lasrc(lnitem,6)
  set filter to &lasrc(lnitem,7)
  return

#if .f.
procedure loadview
  parameters lasrc, lfview
  private lasrc, lfview, lnareas, lnlastarea, lncnt1, llviewopen, lnselect, latmp
  external array lasrc
  if type("lasrc(1)")="U"
    return .f.
  endif
  if type("LFVIEW")!="C" or !file(lfview)
    lfview=""
  endif
  if !empty(lfview)
    set view to (lfview)
    llviewopen=.t.
  else
    llviewopen=.f.
  endif
  lnselect=select()
  lcalias=alias()
  lnareas=alen(lasrc,1) - 1
  if empty(lasrc(1))
    return
  endif
  dimension latmp(1)
  =saveview(@latmp)
  for lncnt1=1 to lnareas
    if !used(lasrc(lncnt1,1))
      =_lvkilldbf(lasrc(lncnt1,2))
      select 0
      use &lasrc(lncnt1,2) alias &lasrc(lncnt1,1) &lasrc(lncnt1,5)
    endif
    select &lasrc(lncnt1,1)
    set order to &lasrc(lncnt1,3)
    set relation to
    if between(lasrc(lncnt1,4),1,reccount())
      goto lasrc(lncnt1,4)
    endif
  endfor
  for lncnt1=1 to lnareas
    select &lasrc(lncnt1,1)
    set relation to &lasrc(lncnt1,6)
    set filter to &lasrc(lncnt1,7)
  endfor
  if !empty(lasrc(lnareas+1,1))
    select &lasrc(lnareas+1,1)
  else
    select 0
  endif
  return

procedure _lvkilldbf
  parameters lfdbf
  private lfdbf, lnpos, lcalias
  if type("LFDBF")!="C"
    return .f.
  endif
  do while .t.
    lnpos=ascan(latmp, lfdbf)
    if lnpos=0
      return .f.
    endif
    lcalias=latmp(asubscript(latmp,lnpos,1),1)
    if used(lcalias)
      use in (lcalias)
    endif
    latmp(asubscript(latmp,lnpos,1),2)="*********"
  enddo
  return
#endif
* SETENTRY(<section>, <entry>, <value>, <memo>, <file>)
*
* Sets <value> of <entry> under <section> from <memo> in
* <file> if <file> is a table.  If <file> is a text file,
* SETENTRY sets <value> of <entry> under <section> in
* <file>.  Works much like INI files in windows.
*
* Calls FSTR(), AMEMO(), GETINFO()
*
#DEFINE CR CHR(13)
#DEFINE CRLF CHR(13)+CHR(10)
procedure setentry
parameters lcsection, lcentry, lcvalue, lcmemo, lfconfig
private lcsection, lcentry, lcvalue, lcmemo, lfconfig, lnsetmemo, laconfig
private llfound, lconerr, lnerr, lnhandle, lcwindow
  if type("LCSECTION")!="C" or empty(lcsection)
    return .f.
  endif
  if type("LCENTRY")!="C" or empty(lcentry)
    return .f.
  endif
  do case
    case type("LCVALUE")="D"
      lcvalue=dtoc(lcvalue)
    case type("LCVALUE")="N"
      lcvalue=fstr(lcvalue)
    case type("LCVALUE")="L"
      lcvalue=iif(lcvalue,"Yes","No")
  endcase
  if type("LFCONFIG")!="C" or !file(lfconfig)
    lconerr=on("ERROR")
    on error lnerr=error()
    lnhandle=fcreate(lfconfig)
    =fputs(lnhandle,"")
    =fclose(lnhandle)
    on error &lconerr
    lfconfig=iif(lnhandle > 0,lfconfig,"")
  endif
  if empty(lfconfig) and (type("LCMEMO")!="C" or empty(lcmemo))
    return .f.
  endif
  do case
    case type(lcmemo)="C"
    case !empty(lfconfig)
    case type(lcmemo) $ "UM"
      if ! "." $ lcmemo
        lcmemo=alias()+"."+lcmemo
      endif
      if ! type(lcmemo) $ "CM"
        return .f.
      endif
    otherwise
      return .f.
  endcase
  lcwindow=stem(lfconfig)
  release window (lcwindow)
  lcsection=alltrim(lcsection)
  lcsection=iif(left(lcsection,1)!="[","[","")+lcsection+;
            iif(right(lcsection,1)!="]","]","")
  lcentry=alltrim(lcentry)
  lnsetmemo=set("MEMOWIDTH")
  lnselect=select()
  set memowidth to 1024
  lftmpset=substr(sys(2015),2)
  if !empty(lfconfig)
    create cursor (lftmpset) (sets m)
    append blank
    append memo sets from (lfconfig)
    lcmemo=alias()+".SETS"
  endif
  dimension laconfig(1)
  =amemo(@laconfig,evaluate(lcmemo))
  lnmline=atcline(lcsection,&lcmemo)+1
  lnlines=memlines(&lcmemo)
  llfound=.f.
  if lnmline=1
    lnmline=alen(laconfig,1)+1
    dimension laconfig(lnmline)
    laconfig(lnmline)=lcsection
    lnmline=lnmline+1
  endif
  if lnmline # 1
    do while left(mline(&lcmemo,lnmline),1)!="[" and lnmline < lnlines
      if upper(getinfo(mline(&lcmemo,lnmline),1,"="))=upper(lcentry)
        llfound=.t.
        laconfig(lnmline)=getinfo(mline(&lcmemo,lnmline),1,"=")+"="+lcvalue
        exit
      endif
      lnmline=lnmline+1
    enddo
    if !llfound
      dimension laconfig(alen(laconfig,1)+1)
      =ains(laconfig,lnmline)
      laconfig(lnmline)=lcentry+"="+lcvalue
    endif
    if type(lcmemo)="M"
      replace (lcmemo) with ""
    else
      store "" to (lcmemo)
    endif
    for lncnt1=1 to alen(laconfig,1)
      if type(lcmemo)="M"
        replace (lcmemo) with laconfig(lncnt1)+CRLF additive
      else
        store evaluate(lcmemo)+laconfig(lncnt1)+CRLF to (lcmemo)
      endif
    endfor
    if !empty(lfconfig)
      copy memo (lcmemo) to (lfconfig)
    endif
  endif
  if used(lftmpset)
    use in (lftmpset)
  endif
  set memowidth to lnsetmemo
  select (lnselect)
return

* DECBIN(<expn>)
* returns a binary-like string from an ascii number
* from 0 to 255
procedure decbin
parameters lndec
private lndec, lcbinary
  do case
    case type("LNDEC")="C"
      lndec=val(lndec)
    case type("LNDEC")!="N"
      return ""
  endcase
  if lndec > 255
    return ""
  endif
  lcbinary=ascbin(chr(lndec))
return lcbinary

*AMEMO(@<array>,<memo>)
*
*stores each line of a <memo> or a character
*variable in an <array>.  line length is based on
*SET MEMOWIDTH setting.
*
procedure amemo
parameters lasrc, lcmemo
private lasrc, lcmemo, lcalias, lnlines
  if ! type("LCMEMO") $ "CM"
    return .f.
  endif
  lnlines=memlines(lcmemo)
  dimension lasrc(lnlines)
  _mline=0
  for lncnt1=1 to lnlines
    lasrc(lncnt1)=mline(lcmemo,1,_mline)
  endfor
  do while empty(lasrc(lnlines)) and lnlines#1
    lnlines=lnlines-1
    dimension lasrc(lnlines)
  enddo
return

* SAVEVIEW(@<array>[,<arealist>])
*
* Saves workareas with record positions to <array>.
* If a comma delimited <arealist> is sent, then only those
* aliases are saved.
*
*   LASRC(x,1)=ALIAS()
*   LASRC(x,2)=<filename>
*   LASRC(x,3)=ORDER()
*   LASRC(x,4)=RECNO()
*   LASRC(x,5)=<exclusive status>
*   LASRC(x,6)=SET("RELATION")
*   LASRC(x,7)=SET("FILTER")
*
* Calls EXT(), GETINFO(), POPINFO()
*
procedure saveview
  parameters lasrc, lcareas
  private lasrc, lcareas, lnareas, lnlastarea, lncnt1, lnselect, lcalias
  external array lasrc
  if type("LASRC(1)")="U"
    return -1
  endif
  if type("LCAREAS")#"C"
    lcareas=""
  endif
  lnareas=0
  lnlastarea=select(1)
  lnselect=select()
  if !empty(lcareas)
    lncnt1=1
    do while !empty(getinfo(lcareas,1))
      lcalias=upper(getinfo(lcareas,lncnt1))
      lcareas=popinfo(lcareas)
      if !used(lcalias) or ext(dbf(lcalias))!="DBF"
        loop
      endif
      select (lcalias)
      if lnareas # 0
        lnareas=alen(lasrc,1)+1
      else
        lnareas=1
      endif
      =_saveview1()
    enddo
  else
    for lncnt1=1 to lnlastarea
      if empty(alias(lncnt1)) or ext(dbf(lncnt1))!="DBF"
        loop
      endif
      select (lncnt1)
      lnareas=lnareas+1
      =_saveview1()
    endfor
  endif
  select (lnselect)
  lnareas=lnareas+1
  dimension lasrc(lnareas,7)
  lasrc(lnareas,1)=alias()
  return lnareas-1

procedure _saveview1
  dimension lasrc(lnareas,7)
  lasrc(lnareas,1)=alias()
  lasrc(lnareas,2)=dbf()
  lasrc(lnareas,3)=order()
  lasrc(lnareas,4)=recno()
  lasrc(lnareas,5)=iif("Excl" $ sys(2011),"EXCLUSIVE","SHARED")
  lasrc(lnareas,6)=set("RELATION")
  lasrc(lnareas,7)=set("FILTER")
  return

#if .f.
procedure saveview
  parameters lasrc, lfview
  private lasrc, lfview, lnareas, lnlastarea, lncnt1, lnselect
  external array lasrc
  if type("lasrc(1)")="U"
    return -1
  endif
  if type("LFVIEW")!="C"
    lfview=""
  endif
  if !empty(lfview)
    create view (lfview)
  endif
  lnareas=0
  lnlastarea=select(1)
  lnselect=select()
  for lncnt1=1 to lnlastarea
    if empty(alias(lncnt1)) or ext(dbf(lncnt1))!="DBF"
      loop
    endif
    select (lncnt1)
    lnareas=lnareas+1
    dimension lasrc(lnareas,7)
    lasrc(lnareas,1)=alias()
    lasrc(lnareas,2)=dbf()
    lasrc(lnareas,3)=order()
    lasrc(lnareas,4)=recno()
    lasrc(lnareas,5)=iif("Excl" $ sys(2011),"EXCLUSIVE","SHARED")
    lasrc(lnareas,6)=set("RELATION")
    lasrc(lnareas,7)=set("FILTER")
  endfor
  select (lnselect)
  lnareas=lnareas+1
  dimension lasrc(lnareas,7)
  lasrc(lnareas,1)=alias()
  return lnareas-1
#endif
* TRANINFO(<item>, <data1>, <data2>[, <delimiter>])
*
* translates <item> in <data1> into corresponding item in <data2> based on
* each's position in data lines delimited by <delimiter>.  default delimiter
* is ",".
*
* Example:
*   =TRANINFO("Z","X,Y,Z","XYLOPHONE","YARN","ZIPPER") returns "ZIPPER"
*
* CALLS FINDINFO(), GETINFO()
*
procedure traninfo
parameters lcinfo, lcline1, lcline2, lcdelim
private lcinfoline, lnitmcnt, lcinfo, lcdelim, lninfo
  if type("LCINFO")!="C" or empty(lcinfo)
    return ""
  endif
  if type("LCLINE1")!="C" or empty(lcline1)
    return ""
  endif
  if type("LCLINE2")!="C" or empty(lcline2)
    return ""
  endif
  if type("LCDELIM")!="C" or len(lcdelim)=0
    lcdelim=","
  endif
  lninfo=findinfo(lcinfo,lcline1,lcdelim)
  lcret=iif(lninfo=0,"",getinfo(lcline2,lninfo,lcdelim))
return lcret

* GETENTRY(<section>[,<entry>][,<value>][,<memo>][,<file>])
*
* Gets <value> of <entry> under <section> from <memo> in
* <file> if <file> is a table.  If <file> is a text file,
* GETENTRY gets <value> of <entry> under <section> in
* <file>.  Works like INI files in windows.  If <entry>
* is empty, GETENTRY returns the contents <section>.
* <memo> can also be a memory variable.  If <entry> is not
* found, <value> is returned as default.
*
* Calls GETINFO()
#DEFINE CR CHR(13)
#DEFINE CRLF CHR(13)+CHR(10)
procedure getentry
parameters lcsection, lcentry, lcvalue, lcmemo, lfconfig
private lcsection, lcentry, lcvalue, lcmemo, lfconfig
private lcsetmemo, lnselect, lftmpset
private lnmline, lnlines, lcsalias
  if type("LCSECTION")!="C"
    return ""
  endif
  if type("LCENTRY")!="C"
    return ""
  endif
  if type("LCVALUE")!="C"
    lcvalue=""
  endif
  lcsalias=""
  if type("LFCONFIG")!="C" or !file(lfconfig)
    lfconfig=""
  endif
  if empty(lfconfig) and (type("LCMEMO")!="C" or empty(lcmemo))
    return lcvalue
  endif
  do case
    case type(lcmemo)="C"
    case !empty(lfconfig)
    case type(lcmemo) $ "UM"
      if ! "." $ lcmemo
        lcmemo=alias()+"."+lcmemo
      endif
      if ! type(lcmemo) $ "CM"
        return ""
      endif
    otherwise
      return ""
  endcase
  lcsection=alltrim(lcsection)
  lcsection=iif(left(lcsection,1)!="[","[","")+lcsection+;
            iif(right(lcsection,1)!="]","]","")
  lcentry=alltrim(lcentry)
  lcsetmemo=set("MEMOWIDTH")
  lnselect=select()
  set memowidth to 1024
  lftmpset=substr(sys(2015),2)
  create cursor (lftmpset) (sets m)
  append blank
  if !empty(lfconfig)
    append memo sets from (lfconfig)
  else
    replace sets with evaluate(lcmemo)
  endif
  lnmline=atcline(lcsection,sets)+1
  lnlines=memlines(sets)
  if lnmline # 1
    do while left(mline(sets,lnmline),1)!="[" and lnmline < lnlines
      if empty(lcentry)
        lcvalue=lcvalue+mline(sets,lnmline)+CRLF
      else
        if upper(getinfo(mline(sets,lnmline),1,"="))=upper(lcentry)
          lcvalue=getinfo(mline(sets,lnmline),2,"=")
          exit
        endif
      endif
      lnmline=lnmline+1
    enddo
  endif
  use in (lftmpset)
  set memowidth to lcsetmemo
  select (lnselect)
return lcvalue

* CHGEXT(<filename>,<ext>)
*
* changes extension of <filename> to <ext>
*
procedure chgext
parameters lcfile, lcext
private lcfile
  if type("LCFILE")!="C"
    lcfile=""
  endif
  if type("LCEXT")!="C"
    lcext=""
  else
    lcext=strtran(lcext,".","")
  endif
  if !empty(lcext)
*    lcfile=fullpath(lcfile)
    lcfile=iif("." $ lcfile,lcfile,trim(lcfile)+".")
    lcfile=substr(lcfile,1,at(".",lcfile))+left(lcext,3)
  endif
return lcfile

* STRIPCHR(<string>)
*
* strips all non-numeric characters from <string>.
*
procedure stripchr
parameters lcstr
private lcstr, lctemp, lncnt1
  if type("LCSTR")#"C" or empty(lcstr)
    return ""
  endif
  lctemp=alltrim(lcstr)
  lcstr=""
  for lncnt1=1 to len(lctemp)
    if isdigit(substr(lctemp,lncnt1,1))
      lcstr=lcstr+substr(lctemp,lncnt1,1)
    endif
  endfor
return lcstr
* _TRACE(<forceit>)
*
*looks if a variable _TRACE exists.  if it does and is .t., the trace and
*debug windows are opened, the system menu is pushed and set to default,
*and the program is suspended.  if <forceit> is .t., all this happens
*with out the _TRACE variable.
*
procedure _trace
parameters llforce
  if type("LLFORCE")#"L"
    llforce=.f.
  endif
  if (type("_TRACE")="L" and _trace) or llforce
    activate window trace
    activate window debug
    push menu _msysmenu
    set sysmenu to default
    suspend
  endif
return
* BLDTDICT(<dictionary>,<tableid>,<file>)
*   dictionary <expc>= tag dictionary filename
*   tableid <expc>= table id
*   file <expc>= filename of table with tags
*
* BLDTDICT adds a tag to a tag dictionary with the following structure:
*
* TABLID      Character      8
* TAGNAME     Character     10
* TAGEXPR     Memo          10
* TAGDESC     Character     40
* BROWFLDS    Memo          10
*
* if <dictionary> does not exist <dictionary> is created, if <dictionary>
* exists, the tags from <file> are appended to <dictionary>.
*
procedure bldtdict
  parameters lfdict, lctable, lffile
  private lfdict, lctable, lffile, lftmp1, lftmp2, lcalias, lncnt1, lastru
  lcalias=alias()
  lftmp1="T~"+right(sys(3),6)
  lftmp2="T~"+right(sys(3),6)
  lncnt1=1
  if type("LFDICT")!="C" or empty(lfdict)
    lfdict=":\TAGDICT"
  endif
  do while !ispath(path(lfdict))
    lfdict=putfile("Tag Dictionary filename",stem(lfdict),"DBF")
    if lastkey()=27
      wait window "Dictionary Update cancelled!" nowait
      return .f.
    endif
  enddo
  do while type("LFFILE")!="C" or !file(lffile)
    if !empty(lcalias)
      lffile=dbf()
      exit
    endif
    lffile=putfile("File to Add to Dictionary","","DBF")
    if lastkey()=27 or empty(lffile)
      wait window "Dictionary Update cancelled!" nowait
      return .f.
    endif
  enddo
  if upper(noext(lffile))=upper(noext(lfdict))
    wait window "Cant include self in Data Dictionary!" nowait
    return .f.
  endif
  if empty(lcalias)
    select 0
    use (lffile)
    lcalias=alias()
  endif
  if type("LCTABLE")!="C" or empty(lctable)
    lctable=noext(stem(lffile))
  endif
  select 0
*  create table (lftmp1) (tablid c(8), tagname c(10), tagexpr m, tagdesc c(40), browflds m)
*  use (lftmp1) alias a_tmp1
  create cursor a_tmp1 (tablid c(8), tagname c(10), tagexpr m, tagdesc c(40), browflds m)
  =afields(lastru)
  do while !empty(tag(lncnt1,lcalias))
    m.tablid=lctable
    m.tagname=tag(lncnt1,lcalias)
    m.tagexpr=key(lncnt1,lcalias)
    m.tagdesc=m.tagname
    lncnt1=lncnt1+1
    append blank
    gather memvar memo
  enddo
  select 0
  if !file(chgext(lfdict,"DBF"))
    create table (lfdict) from array lastru
    index on tablid tag tablid
    index on tagname tag tagname
    index on tablid+tagname tag tabltag
    use
  endif
  use (lfdict) alias a_dict 
  select a_tmp1
  scan
    scatter memvar memo
    select a_dict
    locate for tablid=m.tablid and tagname=m.tagname
    if !found()
      append blank
    else
      release m.browflds, m.tagdesc
    endif
    gather memvar memo
    select a_tmp1
  endscan
  use in a_tmp1
  use in a_dict
  erase (lftmp1+".DBF")
  erase (lftmp1+".FPT")
  select (lcalias)
return .t.

* GETINFO(<data>[,<itemnum>][,<delimiter>])
*
* Extracts item <itemnum> from string <data> that is
* delimited by <delimiter>.
*
procedure getinfo
parameter lcinfoline, lnitem, lcdelim
private lcinfoline, lnitem, lnitmcnt, lcinfo, lcdelim
  if type("LCINFOLINE")!="C" or empty(lcinfoline)
    return ""
  endif
  if type("LNITEM")!="N" or lnitem < 1
    lnitem=1
  endif
  if type("LCDELIM")!="C" or len(lcdelim)=0
    lcdelim=","
  endif
  lcinfoline=alltrim(lcinfoline)
  if right(lcinfoline,1)=lcdelim
    lcinfoline=left(lcinfoline,len(lcinfoline)-1)
  endif
  lnitmcnt=occurs(lcdelim,lcinfoline)+1
  if !between(lnitem,1,lnitmcnt)
    return ""
  endif
  do case
  case at(lcdelim,lcinfoline)=0
    lcinfo=lcinfoline
  case lnitem=lnitmcnt
    lcinfo=substr(lcinfoline,rat(lcdelim,lcinfoline)+1)
  otherwise
    lcinfo=left(lcinfoline,at(lcdelim,lcinfoline,lnitem)-1)
    lcinfo=substr(lcinfo,rat(lcdelim,lcinfo)+1)
  endcase    
  lcinfo=alltrim(lcinfo)
return lcinfo

* ISPATH(<path>)
*
* Checks if <path> is a valid path.
*
procedure ispath
parameter lcpath
private lcpath, lftmp1, lnerr, ladir
private lcsetdefa, lconerr, lnerr
  if type("LCPATH")!="C"
    return .f.
  endif
  lnerr=0
  lcsetdefa=set("DEFAULT")+sys(2003)
  lconerr=on('error')
  on error lnerr=error()
  set defa to &lcpath
  on error &lconerr
  set default to &lcsetdefa
return lnerr=0

* _BLDPJX
* builds all projects in default directory
* calls CHGEXT()
*
procedure _bldpjx
parameter llpause
private x, lconesc, lcsetesc, llpause, lcnowait
  =adir(lapjx,"*.PJX")
  lconesc=on("ESCAPE")
  lcsetesc=set("ESCAPE")
  on escape exit
  lcnowait=iif(type("LLPAUSE")="L" and llpause,"","NOWAIT")
  for x=1 to alen(lapjx,1)
    build app (chgext(lapjx(x,1),"APP")) from (lapjx(x,1))
    if lastkey()=27
      exit
    endif
  endfor
  on escape &lconesc
  set escape &lcsetesc
return


* PROJZIP(<project>[,<parameters>[,<compiled>]])
*
* zips contents of <project>.  <parameters> can be used
* to send the zipfile name and optional parameters.
* default zip file is <project> with parameters -expru.
* <compiled> specifies whether to include compiled code instead of source
* for PRGs, SCXs and MNXs.
* assumes pkzip is available in the path.
* CALLS NOEXT(), STEM(), CHGEXT(), SHOWCONT(), PKZIP.EXE
*
procedure projzip
parameters lfproj, lcparm, llcomp
private lfproj, lcparm, projfile, lcpjxpth, lcproj, lcoldpth, lcobj, lnziphnd,;
        lfpjxlst, lfproj, lnselect, lfzipbat, lnbathnd, lczipcmd, lltrace, llcomp
  if type("LFPROJ")!="C"
    lfproj=""
  endif
  if type("LCPARM")!="C" or empty(lcparm)
    lcparm="-expru"
  endif
  lltrace=type("_TRACE")="L" and _trace
  lfproj=fullpath(chgext(lfproj,"PJX"))
  do while !file(lfproj)
    lfproj=putfile("Choose a project to zip...","","PJX","ZIP")
    if empty(lfproj)
      return .f.
    endif
  enddo
  lnselect=select()
  projfile=stem(lfproj)
  lcpjxpth=path(lfproj)
  lcproj=noext(projfile)
  lcoldpth=sys(5)+sys(2003)
  set default to (lcpjxpth)
  lfpjxlst=chgext(lfproj,"LST")
  lfzipbat=lcpjxpth+"T~"+right(sys(3),6)+".BAT"
  lnziphnd=fcreate(lfpjxlst)
  lnbathnd=fcreate(lfzipbat)
  if lnziphnd < 0 or lnbathnd < 0
    wait window "Cannot open or create output files" nowait
    set default to (lcoldpth)
    select (lnselect)
    return .f.
  endif
  release window (projfile)
  if !used(lcproj)
    use (lfproj) in 0
  endif
  select (lcproj)
  scan for !deleted()
    scatter fields name memo memvar
    do case
      case type = "H"                           &&Project
        lcobj=chgext(lfproj,"PJ?")
        =fputs(lnziphnd,lcobj)
      case type = "x"                           &&File
        lcobj=alltrim(m.name)
        =fputs(lnziphnd,lcobj)
      case type = "s"                           &&Screen
        lcobj=iif(llcomp,chgext(m.name,"SP?"),chgext(m.name,"SC?"))
        =fputs(lnziphnd,lcobj)
      case type = "S"                           &&Screen
        lcobj=chgext(m.name,"SP?")
        =fputs(lnziphnd,lcobj)
      case type = "P"                           &&Program
        lcobj=iif(llcomp,chgext(m.name,"FXP"),alltrim(m.name))
        =fputs(lnziphnd,lcobj)
      case type = "M"                           &&Menu
         lcobj=iif(llcomp,chgext(m.name,"MP?"),chgext(m.name,"MN?"))
         =fputs(lnziphnd,lcobj)
      case type = "Q"                           &&Query
        lcobj=chgext(m.name,"QP?")
        =fputs(lnziphnd,lcobj)
      case type = "R"                           &&Report
        lcobj=chgext(m.name,"FR?")
        =fputs(lnziphnd,lcobj)
      case type = "B"                           &&Label
        lcobj=chgext(m.name,"LB?")
        =fputs(lnziphnd,lcobj)
      case type = "L"                           &&Library
        lcobj=alltrim(m.name)
        =fputs(lnziphnd,lcobj)
      case type = "F"                           &&Format
        lcobj=alltrim(m.name)
        =fputs(lnziphnd,lcobj)
      case type = "D"                           &&Database
        lcobj=alltrim(m.name)
        =fputs(lnziphnd,lcobj)
        lcobj=chgext(m.name,"FPT")
        if file(lcobj)
          =fputs(lnziphnd,lcobj)
        endif
        lcobj=chgext(m.name,"?DX")
        if file(lcobj)
          =fputs(lnziphnd,lcobj)
        endif
      case type = "Z"                           &&Application
        lcobj=alltrim(m.name)
        =fputs(lnziphnd,lcobj)
    endcase
  endscan
  =fclose(lnziphnd)                                && close file
  if lltrace
    modify command (lfpjxlst)
  endif
  if used(lcproj)
    use in (lcproj)
  endif
  if substr(lcpjxpth,2,1)=":"
    =fputs(lnbathnd,left(lcpjxpth,2))
  endif
  =fputs(lnbathnd,"cd "+lcpjxpth)
  if llcomp
    =fputs(lnbathnd,"if exist "+chgext(lfproj,"ZIP")+" del "+chgext(lfproj,"ZIP"))
  endif
  =fputs(lnbathnd,"pkzip "+lcparm+" "+noext(lfproj)+" @"+lfpjxlst)
  if substr(lcoldpth,2,1)=":"
    =fputs(lnbathnd,left(lcoldpth,2))
  endif
  =fputs(lnbathnd,"cd "+lcoldpth)
  =fclose(lnbathnd)
  if lltrace
    modify comm (lfzipbat)
  endif
  lczipcmd="!"+noext(lfzipbat)
  if lltrace
    =showcont("lczipcmd")
  endif
  &lczipcmd
  erase (lfpjxlst)
  erase (lfzipbat)
  set default to (lcoldpth)
  select (lnselect)
return

*BLDTAGS([<dictionary>[,<tableid>[,<file>]]])
*  dictionary <expc> = tag dictionary filename
*  tableid <expc>= table id
*  file <expc>= filename of table to index
*
* Looks up <tablid> in <dictionary> with the following fields:
*
* TABLID      Character      8
* TAGNAME     Character     10
* TAGEXPR     Memo          10
* TAGDESC     Character     40
* BROWFLDS    Memo          10
*
* and indexes <file> on TAGEXPR to TAGNAME.
*
procedure bldtags
parameters lfdict, lctable, lffile
private lfdict, lctable, lffile, lftmp1, lftmp2, lcalias, lataglst, lconerr,;
        lncnt1, lnerr
  lcalias=alias()
  lconerr=on("ERROR")
  lnerr=0
  if type("LFDICT")!="C" or empty(lfdict)
    lfdict="TAGDICT"
  endif
  if !file(chgext(lfdict,"DBF"))
    if used("A_DICT")
      select a_dict
      lfdict=dbf()
      use
    else
      wait window "No Tag Dictionary found!" nowait
      return .f.
    endif
  endif
  if type("LCTABLE")!="C" or empty(lctable)
*    wait window "No Table to Index!" nowait
*    return .f.
    lctable=alias()
  endif
  if type("LFFILE")!="C"
    lffile=lctable
  endif
  if !file(chgext(lffile,"DBF"))
    wait window "Can't Build Tags!" nowait
    return .f.
  endif
  lffile=noext(lffile)
  on error lnerr=error()
  use (lffile) exclusive alias a_tmp1
  on error &lconerr
  if lnerr > 0
    wait window "Can't open file exclusively!" nowait
    return .f.
  endif
  delete tag all
  select 0
  use (lfdict) alias a_dict
  dimension lataglst(1,2)
  lataglst=""
  select tagname, padr(tagexpr,254);
    from (lfdict);
    where tablid=upper(lctable);
    into array lataglst
  use
  select a_tmp1
  for lncnt1=1 to alen(lataglst,1)
    if empty(lataglst(1))
      loop
    endif
    index on &lataglst(lncnt1,2) tag &lataglst(lncnt1,1)
  endfor
return .t.

* ZLOCK([<alias>])
*
* Performs a lock on <alias>.  If no alias is sent, lock
* is on current workarea.  If there is a character field
* called LCKSTAT in the file, an "L" gets placed in the
* the field as a semaphore.
*
procedure zlock
parameters lcalias
  if type("LCALIAS")!="C"
    lcalias=alias()
  endif
  if !used(lcalias)
    return .f.
  endif
  if type(lcalias+".LCKSTAT")!="C"
    return rlock(lcalias)
  endif
  if rlock(lcalias) and empty(evaluate(lcalias+".LCKSTAT"))
    replace (lcalias+".LCKSTAT") with "L"
    unlock in (lcalias)
  else
    return .f.
  endif
return

*BINDEC(<expc>)
*BINARY TO DECIMAL CONVERSION
procedure bindec
parameter lcbinary
private lncnt1, lnasc, lcbinary, lndec
  if type("LCBINARY")!="C"
    return 0
  endif
return asc(binasc(lcbinary))


* AMAXLEN(@<array>[,<column>])
*
* returns maximum length of a string in <column> of
* <array>.  Defaults to first column if <column> isn't
* sent.
*
procedure amaxlen
parameters lasrc, lnkey
private lnsrows, lnscols, lasrc, lnkey, lnmaxlen;
        lncnt1, lncnt2
  if type("LASRC(1)")="U"
    wait window "Invalid array!" nowait
    return -1
  endif
  if type("LNKEY")!="N"
    lnkey=1
  endif
  lnsrows=alen(lasrc,1)
  lnscols=alen(lasrc,2)
  lnmaxlen=0
  for lncnt1=1 to lnsrows
    if lnscols=0
      if type("LASRC(LNCNT1)")!="C"
        loop
      endif
      lnmaxlen=max(lnmaxlen,len(lasrc(lncnt1)))
    else
      if type("LASRC(LNCNT1,LNKEY)")!="C"
        loop
      endif
    endif
    lnmaxlen=max(lnmaxlen,len(lasrc(lncnt1,lnkey)))
  endfor
return lnmaxlen

*APURGE(@<array1>[,@<array2>][,<key>])
*
*purges array of empty records
*<array1> is the source array and <array2> is the
*resultant array <key> is the key column to base
*the purge on.  if there is a .f. in the key column,
*the whole row is removed.  if only one array is sent
*then the resultant array is returned in <array1>
*
procedure apurge
parameters lasrc, ladst, lnkey
private lnsrows, lnscols, lasrc, ladst, lnkey, lndrows, lndcols,;
        lncnt1, lncnt2, llsame
  if type("LASRC(1)")="U"
    wait window "Invalid arrays!" nowait
    return .f.
  endif
  if type("LADST(1)")="U"
    llsame=.t.
  else
    llsame=.f.
  endif
  if type("LNKEY")!="N"
    lnkey=1
  endif
  lnsrows=alen(lasrc,1)
  lnscols=alen(lasrc,2)
  lndrows=0
  for lncnt1=1 to lnsrows
    if lnscols=0
      if type("LASRC(LNCNT1)")="L" and !lasrc(lncnt1)
        loop
      endif
    else
      if type("LASRC(LNCNT1,LNKEY)")="L" and !lasrc(lncnt1,lnkey)
        loop
      endif
    endif
    lndrows=lndrows+1
    if lnscols=0
      dimension ladst(lndrows)
      ladst(lndrows)=lasrc(lncnt1)
    else
      dimension ladst(lndrows,lnscols)
      for lncnt2=1 to lnscols
        ladst(lndrows,lncnt2)=lasrc(lncnt1,lncnt2)
      endfor
    endif
  endfor
  if type("LADST(1)")="U"
    if lnscols=0
      dimension ladst(1)
    else
      dimension ladst(1,lnscols)
    endif
    ladst=""
  endif
  if llsame
    lndrows=alen(ladst,1)
    lndcols=alen(ladst,2)
    if lndcols=0
      dimension lasrc(lndrows)
    else
      dimension lasrc(lndrows,lndcols)
    endif
    =acopy(ladst,lasrc)
  endif
return .t.


* ALIB(<array>)
*
* Puts the list of open libraries into <array>
*
procedure alib
parameters lalibs
private lalibs, lclibs, lncnt1
  if type("LALIBS(1)")="U"
    return .f.
  endif
  dimension lalibs(1)
  lalibs=""
  lncnt1=1
  lclibs=set("LIBRARY")
  do while !empty(getinfo(lclibs,lncnt1))
    dimension lalibs(lncnt1)
    lalibs(lncnt1)=getinfo(lclibs,lncnt1)
    lncnt1=lncnt1+1
  enddo
return

* ISEMPTY([<alias>])
*
* Checks if <alias> has an empty DBF.  If <alias> is
* not sent, the current workarea is checked.
*
procedure isempty
parameter lcworkarea
private llisempty, lnrecno, lnselct, lcworkarea
  lnselect=select()
  llisempty=.t.
  do case
    case type("LCWORKAREA")="N"
      lcworkarea=iif(between(lcworkarea,0,select(1)),alias(lcworkarea),"")
    case type("LCWORKAREA")!="C"
      lcworkarea=lcalias
  endcase
  do case
    case used(lcworkarea)
      select (lcworkarea)
    case empty(alias())
      wait window "No Database in use!" nowait
      return .f.
    otherwise
      wait window "Alias not found!" nowait
      return .f.
  endcase
  lnrecno=recno()
  go top
  llisempty=eof()
  if !llisempty and between(lnrecno,1,reccount())
    goto lnrecno
  endif
  select (lnselect)
return llisempty

* BLDTABL(<dictionary>,<tableid>,<table>)
*
* Builds <table> based on <tableid> in <dictionary>.
*
procedure bldtabl
parameters lfdict, lctable, lffile
private lfdict, lctable, lffile, lftmp1, lftmp2, lcalias, lastruct
  lcalias=alias()
  if type("LFDICT")!="C" or empty(lfdict)
    lfdict="DATADICT"
  endif
  if !file(chgext(lfdict,"DBF"))
    if used("A_DICT")
      select a_dict
      lfdict=dbf()
      use
    else
      wait window "No Data Dictionary found!" nowait
      return .f.
    endif
  endif
  if type("LCTABLE")!="C" or empty(lctable)
    wait window "No Table to Build!" nowait
    return .f.
  endif
  if type("LFFILE")!="C"
    lffile=lctable
  endif
  if !ispath(path(lffile)) or file(chgext(lffile,"DBF"))
    wait window "Can't Build Table!" nowait
    return .f.
  endif
  select 0
  use (lfdict) alias a_dict
  select field_name, field_type, field_len, field_dec;
    from (lfdict);
    where tablid=upper(lctable);
    into array lastruct
  use
  create table (lffile) from array lastruct
  use
return .t.

* AFNDROW(<array>,<item>)
*
* this procedure returns the row that <item> exists in <array>
*
procedure afndrow
parameters lasrc, lxitem
private lasrc, lxitem, lnelem, lnrow
  if type("LASRC(1)")="U"
    return -1
  endif
  lnelem=ascan(lasrc,lxitem)
  lnrow=iif(lnelem>0,asubscript(lasrc,lnelem,1),0)
return lnrow


* CRYPT(<string>)
*
* Encrypts/decrypts <string>.
*
procedure crypt
parameters lcstring
private lnstrlen, lnchr, lccrypt, lcstring
  lnstrlen=len(lcstring)
  lccrypt=""
  for lncnt1=1 to lnstrlen
    lnchr=decxor(mod(lncnt1,255),asc(substr(lcstring,lncnt1,1)))
    lccrypt=lccrypt+chr(lnchr)
  endfor
return lccrypt

* FDOW(<date>[,<day>][,next])
*
* returns date of <day> of week in same week as <date>.  if <next> is true,
* returns the next <day> after <date>.
*
procedure fdow
parameters lddate, lnday, llnext
private lddate, lnday
  do case
    case type("LDDATE")="C"
      if at("/",lddate)=0
        lddate=transform(lddate,"@R 99/99/99")
      endif
      lddate=ctod(lddate)
    case type("LDDATE")!="D" or empty(lddate)
      lddate=date()
  endcase
  if type("LNDAY")!="N"
    lnday=1
  endif
  if dow(lddate)!=lnday
    do case
      case llnext
        lddate=lddate-dow(lddate)+iif(dow(lddate)<lnday,lnday,lnday+7)
      case !llnext
        lddate=lddate-dow(lddate)+lnday
    endcase
  endif
return lddate

* DBFCODE([<alias>[,<type>]])
*
* Generates source code to create table specified by
* <alias>.  If <type> is "T" (default) the source code
* is to create a table, otherwise it is to create cursor.
*
procedure dbfcode
parameters lcname, lctype
private lcname, lctype, lcalias, lcline, lcfld, xcnt1, lctmp1
  lctmp1="T~"+right(sys(3),2)
  if type("LCNAME")!="C"
    lcname=alias()
  endif
  if type("LCTYPE")!="C"
    lctype="T"
  endif
  if empty(alias())
    wait window "no database is opened"
  else
    lcalias=alias()
    select 0
    create cursor temp (code m)
    append blank
    lcline="create"+iif(lctype="T"," table "," cursor ")+lcname+" ("
    select (lcalias)
    copy structure extended to (lctmp1)
    select 0
    use (lctmp1) alias a_tmp1
    scan
      do case 
        case field_type="C"
          lcfld=trim(lower(field_name))+" c("+alltrim(str(field_len))+")"
        case field_type="N"
          lcfld=trim(lower(field_name))+" n("+alltrim(str(field_len))+;
                iif(field_dec>0,","+alltrim(str(field_dec)),"")+")"
        otherwise
          lcfld=trim(lower(field_name))+" "+lower(field_type)
      endcase
      lcline=lcline+lcfld+", "
    endscan        
    lcline=left(trim(lcline),len(trim(lcline))-1)
    lcline=lcline+")"+chr(13)
    select temp
    replace code with lcline
    lntag=1
    select (lcalias)
    do while !empty(tag(cdx(1),lntag))
      lcline="index on "+sys(14,lntag)+" tag "+tag(cdx(1),lntag)+chr(13)
      select temp
      replace code with lcline additive
      lntag=lntag+1
      select (lcalias)
    enddo
    select temp
    modify memo code in screen
*    modify memo code 
    use in a_tmp1
    erase (lctmp1+".DBF")
    select (lcalias)
  endif
return

* BOM([<date>])
*
* Returns beginning of month of <date>.
*
procedure bom
parameters lddate
private lddate
  do case
    case type("lddate")="C"
      if at("/",lddate)=0
        lddate=transform(lddate,"@R 99/99/99")
      endif
      lddate=ctod(lddate)
    case type("lddate")!="D"
      lddate=date()
  endcase
  lddate=ctod(stuff(dtoc(lddate),4,2,"01"))
return lddate

* GOYEAR(<date>,<years>)
*
* Advances <date> by <years> years.
*
procedure goyear
parameters lddate, lninc
private lddate, lninc
  do case
    case type("lddate")="C"
      if at("/",lddate)=0
        lddate=transform(lddate,"@R 99/99/99")
      endif
      lddate=ctod(lddate)
    case type("lddate")!="D"
      lddate=date()
  endcase
  if type("lninc")!="N"
    lninc=0
  endif
  if left(dtos(lddate),5)="02/29"
    lddate=ctod(stuff(dtoc(lddate),4,2,"28"))
    lddate=eom(ctod(left(dtoc(lddate),6)+str(year(lddate)+lninc,4)))
  else
    lddate=ctod(left(dtoc(lddate),6)+str(year(lddate)+lninc,4))
  endif
return lddate

* BOY(<date>)
*
* Returns beginning of year of <date>.
*
procedure boy
parameters lddate
private lddate
  do case
    case type("lddate")="C"
      if at("/",lddate)=0
        lddate=transform(lddate,"@R 99/99/99")
      endif
      lddate=ctod(lddate)
    case type("lddate")!="D"
      lddate=date()
  endcase
  lddate=ctod(stuff(dtoc(lddate),1,5,"01/01"))
return lddate

* EOY([<expd>])
*
* Returns end of year of <date>.
*
procedure eoy
parameters lddate
private lddate
  do case
    case type("lddate")="C"
      if at("/",lddate)=0
        lddate=transform(lddate,"@R 99/99/99")
      endif
      lddate=ctod(lddate)
    case type("lddate")!="D"
      lddate=date()
  endcase
  lddate=ctod(stuff(dtoc(lddate),1,5,"12/31"))
return lddate

* ISARRAY(@<array>)
*   returns .t. if <array> is an array
*
procedure isarray
parameters lasrc, llarray
private lasrc, llarray
  if type("LASRC(1)")!="U"
    llarray=.t.
  else
    llarray=.f.
  endif
return llarray

* ASCBIN(<expc>)
*
* turns an ascii character into binary representation
*
procedure ascbin
parameters lcascii
private lcascii, lncnt1, lnasc, lcbinary
  if type("LCASCII")!="C"
    return ""
  endif
  lcbinary=""
  lnasc=asc(substr(lcascii,1,1))
  for lncnt1=7 to 0 step -1
    if lnasc >= 2^lncnt1
      lcbinary=lcbinary+"1"
      lnasc=lnasc-2^lncnt1
    else
      lcbinary=lcbinary+"0"
    endif
  endfor
return lcbinary

* STEM(<pathname>[,<ext>])
*
* Returns filename of full <pathname> only.  <ext>
* overrides the extension of the filename.
*
procedure stem
parameters lcfile, lcext
private lcfile, lcstem
  if type("LCFILE")!="C"
    lcfile=""
  endif
  if type("LCEXT")!="C"
    lcext=""
  else
    lcext=strtran(lcext,".","")
  endif
  lcstem=strtran(lcfile,path(lcfile),"")
  if !empty(lcext)
    lcstem=iif("." $ lcstem,lcstem,trim(lcstem)+".")
    lcstem=substr(lcstem,1,at(".",lcstem))+left(lcext,3)
  endif
  lcfile=lcstem
return lcstem


* DECTIME(<number>[,<ampm>])
*
* Converts <number> into a character representation of time.
* If <ampm> is .t. then the time returned in AM/PM
* format, otherwise the time is returned in 24hr format.
*
procedure dectime
parameters lntime, llampm
private lntime, lctime, lnmin, lcmin, lnhours, lchours, lcampm
  if type("LNTIME")!="N" or !between(lntime,0,24)
    return ""
  endif
  lcampm="  "
  lnhours=int(lntime)
  lnmin=lntime-lnhours
  if llampm
    do case
      case mod(lnhours,12)=0
        lcampm=iif(lnhours=0 or lnhours=24,"AM","PM")
        lnhours=12
      case lnhours>12
        lcampm="PM"
        lnhours=mod(lnhours,12)
      otherwise
        lcampm="AM"
    endcase
  endif
  lchours=padl(ltrim(str(lnhours,2)),2,"0")
  lcmin=padl(ltrim(str(lnmin*60,2)),2,"0")
  lctime=trim(lchours+":"+lcmin+" "+lcampm)
return lctime

* TIMEDEC(<timestring>[,<roundfactor>])
*
* Converts <timestring> to a decimal representation.
* <timestring> is a string of the form "HH:MM:SS".
* If <timestring> doesn't contain at least one colon (:),
* or time values are not valid, timedec returns -1.
* <roundfactor> is the rounding factor for rounding the hours.
* The default is 0.
*
procedure timedec
parameters lctime, lnfact, lntime
private lctime,lnlen,lnpos,lnhrs,lnmin,lnsec,lntime, lnfact, lcampm
  if type("LCTIME")!="C"
    return -1
  endif
  if type("LNFACT")!="N"
    lnfact=0
  endif
  lntime=0
  lcampm=""
  * get position of first and second occurrences of ':'
  lctime=alltrim(lctime)
  if occurs(":",lctime) > 1
    lctime=substr(lctime,1,at(":",lctime,2)-1)
  endif
  if upper(right(lctime,2)) $ "AM|PM"
    lcampm=upper(right(lctime,2))
    lctime=substr(lctime,1,at(lcampm,upper(lctime))-1)
  endif
  * error checking
  lnpos=at(":",lctime)
  do case
    case lnpos==0
      lntime=-1
    otherwise
      lnhrs = val(substr(lctime,1,lnpos-1))
      do case
        case lcampm="AM" and lnhrs >= 12
          lnhrs=iif(lnhrs=12,0,-1)
        case lcampm="PM" and lnhrs < 12
          lnhrs=lnhrs+12
      endcase
      lnmin = val(substr(lctime,lnpos+1,2))   && from ':' to end
      if between(lnmin,0,59) and between(lnhrs,0,23)
        lnmin=iif(lnfact=0,round((lnmin/60),2),;
                  round((lnmin/60)/lnfact,2)*lnfact)
        lntime=lnhrs+lnmin
      else
        lntime=-1
      endif
  endcase
return lntime


* APOPUP(@<array>[,<popup>][,<column>][,<toprow>][,<leftcol>]
*                [,<height>][,<width>])
* creates <popup> based on <column> of <array>
* at <toprow>, <leftcol> with a size of <height>, <width>.
* Calls: AMAXLEN()
procedure apopup
parameters lasrc, lcpopname, lnkey, lnrow, lncol, lnheight, lnwidth
private lnsrows, lnscols, lasrc, lnkey, lnheight, lnwidth;
        lncnt1, lncnt2, lnbar, lcwind
  if type("LASRC(1)")="U"
    wait window "Invalid array!" nowait
    return .f.
  endif
  if type("LCPOPNAME")!="C"
    wait window "Invalid popup name!" nowait
    return .f.
  endif
  if type("LNKEY")!="N"
    lnkey=1
  endif
  if type("LNROW")!="N"
    lnrow=1
  endif
  if type("LNCOL")!="N"
    lncol=1
  endif
  if type("LNHEIGHT")!="N"
    lnheight=min(alen(lasrc,1),10)
  endif
  if type("LNWIDTH")!="N"
    lnwidth=amaxlen(@lasrc,lnkey)
  endif
  lnsrows=alen(lasrc,1)
  lnscols=alen(lasrc,2)
  lnbar=1
  define popup (lcpopname);
    from lnrow, lncol;
    to lnrow+lnheight, lncol+lnwidth;
    scroll
  for lncnt1=1 to lnsrows
    if lnscols=0
      if type("LASRC(LNCNT1)")!="C"
        loop
      endif
      define bar lnbar of (lcpopname) prompt lasrc(lncnt1)
    else
      if type("LASRC(LNCNT1,LNKEY)")!="C"
        loop
      endif
      define bar lnbar of (lcpopname) prompt lasrc(lncnt1,lnkey)
    endif
    lnbar=lnbar+1
  endfor
return .t.


* ARESIZE(@<array1>, @<array2>)
*
* matches column widths of two arrays by
* sizing the smaller array to
* match the number of columns with with larger array
*
procedure aresize
parameters lasrc, ladst
private ladst, lasrc, lndrows, lndcols, lnsrows, lnscols, lncnt1, lncnt2,;
        latemp, lntrows, lntcols
  if type("LASRC(1)")="U" and type("LADST(1)")="U"
    wait window "Need two arrays!" nowait
    return
  endif
  lndrows=alen(ladst,1)
  lndcols=alen(ladst,2)
  lnsrows=alen(lasrc,1)
  lnscols=alen(lasrc,2)
  lntcols=max(lndcols,lnscols)
  if lndcols=lnscols
    return .t.
  endif
  dimension latemp(1,lntcols)
  lcarray=iif(lndcols > lnscols,"LASRC","LADST")
  for lncnt1=1 to evaluate("ALEN("+lcarray+",1)")
    dimension latemp(lncnt1,lntcols)
    for lncnt2=1 to evaluate("ALEN("+lcarray+",2)")
      latemp(lncnt1,lncnt2)=&lcarray.(lncnt1,lncnt2)
    endfor
  endfor
  lntrows=alen(latemp,1)
  dimension &lcarray.(lntrows,lntcols)
  =acopy(latemp,&lcarray)  
return .t.

* REGTAB([<item>[,<action>]])
*
* This registers <item> in a global array called
* _REGTAB.  The first column holds the item name and
* the second column holds the number of times item was
* used.  <action> is the desired action. If
* <action> is "OPEN", the second column is incremented.
* if <action> is "CLOSE" the second column is decremented.
* The "SET" paramater can be used to set the item to a specific
* number.  The "CLEAR" parameter sets the item to 0.
* "STATUS" returns the number that item is set to.
*
procedure regtab
parameters lcaction, lctable, lxopt1
private lctable, lcaction, lxopt1, lnrow, lnalen, lncnt1, lnret
  if type("LCACTION")!="C"
    lcaction="OPEN"
  endif
  lcaction=upper(lcaction)
  if type("LCTABLE")!="C" or empty(lctable)
    do case
      case inlist(lcaction,"OPEN","CLOSE","CLEAR","SET")
        return -1
      case inlist(lcaction,"STATUS")
        return -1
      otherwise
        lctable=""
    endcase
  endif
  lctable=upper(lctable)
  if type("_REGTAB(1)")="U"
    release _regtab
    public array _regtab(1,2)
    _regtab(1,1)=space(10)
    _regtab(1,2)=0
  endif
  lnret=0
  lnrow=ascan(_regtab,lctable)
  if lnrow # 0
    lnrow=asubscript(_regtab,lnrow,1)
  endif
  lnalen=iif(empty(_regtab(1)),0,alen(_regtab,1))
  do case
    case lcaction="OPEN"
      if lnrow=0
        lnalen=lnalen+1
        dimension _regtab(lnalen,2)
        _regtab(lnalen,1)=lctable
        _regtab(lnalen,2)=1
      else
        _regtab(lnrow,2)=_regtab(lnrow,2)+1
      endif
    case lcaction="CLOSE"
      if lnrow # 0
        _regtab(lnrow,2)=_regtab(lnrow,2)-1
      endif
    case lcaction="CLEAR"
      if lnrow # 0
        _regtab(lnrow,2)=0
      endif
    case lcaction="DESTROY"
      for lncnt1=1 to lnalen
        if used(trim(_regtab(lncnt1,1)))
          use in (trim(_regtab(lncnt1,1)))
        endif
      endfor
      release _regtab
    case lcaction="STATUS"
      if lnrow # 0
        lnret=_regtab(lnrow,2)
      else
        lnret=-1
      endif
    case lcaction="SET"
      if type("LXOPT1")="N"
        if lnrow=0
          lnalen=lnalen+1
          dimension _regtab(lnalen,2)
          _regtab(lnalen,1)=lctable
          _regtab(lnalen,2)=lxopt1
        else
          _regtab(lnrow,2)=lxopt1
        endif
      endif
  endcase
return lnret

* BLDCAL(@<array>)
*
* Converts <array> to a 6x7 array representation
* of a calendar.
*
procedure bldcal
parameters ladate, lddate
private ladate, lddate, lncntw, lncntd, lnlstd, lnfill
  if type("LADATE(1)")="U"
    wait window "Need an array!" nowait
    return
  endif
  dimension ladate(6,7)
  lddate=valdte(lddate)
  lnfrst=dow(bom(lddate))
  lnlstd=day(eom(lddate))
  for lncntw=1 to 6
    for lncntd=1 to 7
      lnfill=((lncntw-1)*7)+lncntd-lnfrst+1
      ladate(lncntw,lncntd)=iif(between(lnfill,1,lnlstd),str(lnfill,2),"  ")
    endfor
  endfor
return


* AAPEND(@<array1>,@<array2>,[<resize>])
*
* appends the contents of array2 into array1
* adjusts number of columns in smaller array if <resize>
* is .t.
*
procedure aapend
parameters ladst, lasrc, llresize
private ladst, lasrc, lndrows, lndcols, lnsrows, lnscols, lncnt1, lncnt2,;
        llresize
  if type("LASRC(1)")="U" and type("LADST(1)")="U"
    wait window "Need two arrays!" nowait
    return
  endif
  if type("LLRESIZE")!="L"
    llresize=.f.
  endif
  lndrows=alen(ladst,1)
  lndcols=alen(ladst,2)
  lnsrows=alen(lasrc,1)
  lnscols=alen(lasrc,2)
  if llresize and lnscols # lndcols
    do aresize with lasrc, ladst
  endif 
  for lncnt1=1 to lnsrows
    lndrows=lndrows+1
    if lndcols=0
      dimension ladst(lndrows)
    else
      dimension ladst(lndrows,lndcols)
    endif
    do case
      case lnscols=0 and lndcols=0
        ladst(lndrows)=lasrc(lncnt1)
      case lnscols=0
        ladst(lndrows,1)=lasrc(lncnt1)
      case lndcols=0
        ladst(lndrows)=lasrc(lncnt1,1)
      otherwise
        for lncnt2=1 to lnscols
          if lncnt2 > lndcols
            exit
          endif
          ladst(lndrows,lncnt2)=lasrc(lncnt1,lncnt2)
        endfor
    endcase
  endfor
return


* PATH(<pathname>)
*
* returns path of full <pathname>
*
procedure path
parameters lcfile
private lcfile, lcpth
  if type("LCFILE")!="C"
    lcfile=""
  endif
  if rat("\",lcfile)>0
    lcpth=substr(lcfile,1,rat("\",lcfile))
  else
    lcpth=""
  endif
  lcfile=lcpth
return lcpth


* NOEXT(<filename>)
*
* returns <filename> with the extension stripped
*
procedure noext
parameters lcfile
private lcfile
  if type("LCFILE")!="C"
    lcfile=""
  endif
  if "." $ lcfile
    lcfile=substr(lcfile,1,at(".",lcfile)-1)
  endif
return lcfile


* PUSHINFO(<item>,<data>[,<expn>][,<expc3>])
*
* "Pushes" information <item> into data line <data>
* delimited by <delimeter> at <position>.  Default
* is position 1.  Default delimiter is ",".  Returns
* result of "push".
*
procedure pushinfo
parameter lcinfo, lcinfoline, lnitem, lcdelim
private lcinfoline, lnitem, lnitmcnt, lcinfo, lcdelim, llappend
  if type("LCINFOLINE")!="C"
    return ""
  endif
  if type("LCINFO")!="C" or empty(lcinfo)
    return iif(empty(lcinfo),lcinfoline,"")
  endif
  if type("LNITEM")!="N" or lnitem < 1
    lnitem=1
  endif
  if type("LCDELIM")!="C"
    lcdelim=","
  endif
  lnitmcnt=occurs(lcdelim,lcinfoline)+1
*  if lnitem > lnitmcnt
*    lnitem=lnitmcnt
*  endif
  do case
    case lnitem=1
      if !empty(lcinfoline)
        lcinfoline=lcinfo+lcdelim+lcinfoline
      else
        lcinfoline=alltrim(lcinfo)
      endif
    case lnitem>lnitmcnt
      lcinfoline=iif(!empty(lcinfoline),lcinfoline+lcdelim,"")+lcinfo
    otherwise
      lcinfoline=stuff(lcinfoline,at(lcdelim,lcinfoline,lnitem-1)+1,0,;
                       lcinfo+lcdelim)
  endcase    
  lcinfoline=alltrim(lcinfoline)
return lcinfoline

*VIEWCODE()
*
*generates code based on current view
*
*Calls: SAVEVIEW(), _DEBUG
*
procedure viewcode
private laview, x
  dimension laview(1)
  =saveview(@laview)
  =_debug("ON")
  for x=1 to alen(laview,1)
    \if !used("<<laview(x,1)>>")
    \  select 0
    \  use <<laview(x,2)>> alias <<laview(x,1)>>
    if !empty(laview(x,3))
      \\ order <<laview(x,3)>>
    endif
    \\ <<laview(x,5)>>
    \endif
    if !empty(laview(x,7))
      \set filter to <<laview(x,7)>>
    endif
  endfor
  for x=1 to alen(laview)
    if empty(laview(x,6))
      loop
    endif
    \select <<laview(x,1)>>
    \set relation to <<laview(x,6)>>
  endfor
  =_debug("SHOW")
return

* FINDDBF(<filename>)
*
* returns select area of <filename> if it's in use.
* Calls CHGEXT()
*
procedure finddbf
parameters lfdbf
private lfdbf, lnlastarea, lnselect, lnoldsel, lcsetexact
  if type("LFDBF")!="C"
    return .f.
  endif
  if ! "." $ lfdbf
    lfdbf=chgext(upper(lfdbf),"DBF")
  endif
  lcsetexact=set("EXACT")
  lnlastarea=select(1)
  lnselect=0
  set exact on
  for lncnt1=1 to lnlastarea
    if fullpath(lfdbf)=dbf(lncnt1)
      lnselect=lncnt1
      exit
    endif
  endfor
  set exact &lcsetexact
return lnselect

*_ZIPALL
*
*projzips all projects in default directory
*
procedure _zipall
private lapjx, lncnt1, lnloop
  lncnt1=adir(lapjx,"*.pjx")
  if lncnt1=0
    return .f.
  endif
  for lnloop=1 to alen(lapjx,1)
    =projzip(lapjx(lnloop,1))
  endfor
return

* ZUNLOCK([<alias>])
*
* Performs an unlock on <alias>.  if no alias is sent, the
* unlock is on the current workarea.  If there is
* a character field called LCKSTAT in the file, it gets
* blanked.
*
procedure zunlock
parameters lcalias
  if type("LCALIAS")!="C"
    lcalias=alias()
  endif
  if !used(lcalias)
    return .f.
  endif
  if type(lcalias+".LCKSTAT")!="C"
    unlock in (lcalias)
    return
  endif
  if rlock(lcalias)
    replace (lcalias+".LCKSTAT") with " "
    unlock in (lcalias)
  else
    return .f.
  endif
return


* INTRAND([<maxnum>])
*
* returns a random integer from 1 to <maxnum>
*
procedure intrand
parameters lnmax
  if type("LNMAX")!="N"
    lnmax=100
  endif
return int(rand()*lnmax)+1

* BINARY AND
procedure binand
parameters lcbin1, lcbin2
private lncnt1, lcbinary, lcbin1, lcbin2
  if type("LCBIN1")!="C" or type("LCBIN2")!="C"
    return ""
  endif
*  lnasc=0
  lcbinary=""
  lcbin1=padl(lcbin1,8,"0")
  lcbin2=padl(lcbin2,8,"0")
  for lncnt1=1 to 8
    lcbinary=lcbinary+iif(substr(lcbin1,lncnt1,1)="1" and;
                          substr(lcbin2,lncnt1,1)="1",;
                          "1","0")
  endfor
return lcbinary

* BINARY XOR
procedure binxor
parameters lcbin1, lcbin2
private lncnt1, lcbinary, lcbin1, lcbin2
  if type("LCBIN1")!="C" or type("LCBIN2")!="C"
    return ""
  endif
*  lnasc=0
  lcbinary=""
  lcbin1=padl(lcbin1,8,"0")
  lcbin2=padl(lcbin2,8,"0")
  for lncnt1=1 to 8
    lcbinary=lcbinary+iif(substr(lcbin1,lncnt1,1)=substr(lcbin2,lncnt1,1),;
                          "0","1")
  endfor
return lcbinary

* BINARY OR
procedure binor
parameters lcbin1, lcbin2
private lncnt1, lcbinary, lcbin1, lcbin2
  if type("LCBIN1")!="C" or type("LCBIN2")!="C"
    return ""
  endif
*  lnasc=0
  lcbinary=""
  lcbin1=padl(lcbin1,8,"0")
  lcbin2=padl(lcbin2,8,"0")
  for lncnt1=1 to 8
    lcbinary=lcbinary+iif(substr(lcbin1,lncnt1,1)="1" or;
                          substr(lcbin2,lncnt1,1)="1",;
                          "1","0")
  endfor
return lcbinary

* CHANCE([<chance>])
*
* Returns .T. or .F. based on the value of <chance> between 0 and 100.
*
procedure chance
parameters lnchance
  if type("LNCHANCE")!="N"
    lnchance=50
  endif
return rand()*100 < lnchance

* DECIMAL XOR
procedure decxor
parameters lndec1, lndec2
private lncnt1, lndec, lndec1, lndec2
  if type("LNDEC1")!="N" or type("LNDEC2")!="N"
    return ""
  endif
return bindec(binxor(decbin(lndec1),decbin(lndec2)))


* DECIMAL AND
procedure decand
parameters lndec1, lndec2
private lncnt1, lndec, lndec1, lndec2
  if type("LNDEC1")!="N" or type("LNDEC2")!="N"
    return ""
  endif
return bindec(binand(decbin(lndec1),decbin(lndec2)))


* DECIMAL OR
procedure decor
parameters lndec1, lndec2
private lncnt1, lndec, lndec1, lndec2
  if type("LNDEC1")!="N" or type("LNDEC2")!="N"
    return ""
  endif
return bindec(binor(decbin(lndec1),decbin(lndec2)))


* VALDATE(<any>)
*
* takes any type of parameter and converts it into date
* format.
*
procedure valdate
parameters lddate
private lddate
  do case
    case type("lddate")="C"
      if at("/",lddate)=0
        lddate=transform(lddate,"@R 99/99/99")
      endif
      lddate=ctod(lddate)
    case type("lddate")!="D"
      lddate={}
  endcase
return lddate

* SHOWCONT(<varname>)
*
* Shows contents of variable named <varname> in a window.
*
procedure showcont
parameters lcvar
private lcvar, lctype, m.contents, lcalias, lcwindow
  if type("LCVAR")!="C"
    wait window "Please send a variable name!"
    return .f.
  endif
  m.contents=evaluate(LCVAR)
  do case
    case type("M.CONTENTS")="D"
      m.contents="{"+dtoc(m.contents)+"}"
    case type("M.CONTENTS")="L"
      m.contents=iif(m.contents,".TRUE.",".FALSE.")
    case type("M.CONTENTS")="N"
      m.contents=str(lcvar,10,2)
    case type("M.CONTENTS")="U"
      wait window "Variable doesn't exist!"
      return .f.
  endcase
  lcalias=alias()
  create cursor sys(2015) (contents m)
  append blank
  gather memvar memo
  lcwindow=sys(2015)
  define window (lcwindow);
    from 0,0 to 15,79;
    color scheme 10;
    font "MS Sans Serif",10;
    title "Contents of "+lcvar;
    float grow close zoom
  move window (lcwindow) center
  modify memo contents window (lcwindow)
  release window (lcwindow)
  if !empty(lcalias)
    select (lcalias)
  else
    select 0
  endif
return

*PASSGET(<getfield>,<pwlength>,<passchar>)
*
*when placed in the when clause of <getfield>, creates a password field with
*<passchar> as the character.  the length can be limited by <pwlength>.
*
procedure passget
parameters lcgetfld, pwlen,lcphold
private lctemp, lcgetfld, xlen, lcpass, lcphold, lckeyhit, pwlen, lnvalid
  if type("LCGETFLD")!="C"
    lcgetfld=varread()
  endif
  if type(lcgetfld)!="C"
    return .f.
  endif
  if type(lcphold)!="C" or len(lcphold)#1
    lcphold="*"
  endif
  if type("PWLEN")!="N"
    pwlen=len(evaluate(lcgetfld))
  endif
  store '' to (lcgetfld),lcpass
  lckeyhit=0
  store padr(lcpass,pwlen) to (lcgetfld)
  show get &lcgetfld
  store '' to (lcgetfld),lcpass
  do while lckeyhit<>13
    lckeyhit=inkey(0,"S")
    if inlist(lckeyhit,9,13,27,5,15,24)
         exit
    endif
    xlen=len(evaluate(lcgetfld))
    if inlist(lckeyhit,19,127)
      if xlen=0
        loop
      endif
      store left(evaluate(lcgetfld),xlen-1) to (lcgetfld)
      lcpass=left(lcpass,xlen-1)
    else
      if xlen=pwlen or !between(lckeyhit,32,126)
        ?? chr(7)
        loop
      endif
      store evaluate(lcgetfld)+chr(lckeyhit) to (lcgetfld)
      lcpass=lcpass+lcphold
    endif

    lctemp = evaluate(lcgetfld)
    store  padr(lcpass,pwlen) to (lcgetfld)
    show get &lcgetfld
    store lctemp to (lcgetfld)
  enddo
  _curobj=_curobj+iif(inlist(lastkey(),5,15),-1,1)

return

* AMOVER(@<array>[,<popup>][,<column>][,<toprow>][,<leftcol>]
*                [,<height>][,<width>])
*
* creates a mover <popup> based on <column> of <array>
* at <toprow>, <leftcol> with a size of <height>, <width>
* Calls: AMAXLEN()
*
procedure amover
parameters lasrc, lcpopname, lnkey, lnrow, lncol, lnheight, lnwidth
private lnsrows, lnscols, lasrc, lnkey, lnheight, lnwidth;
        lncnt1, lncnt2, lnbar, lcwind
  if type("LASRC(1)")="U"
    wait window "Invalid array!" nowait
    return .f.
  endif
  if type("LCPOPNAME")!="C"
    wait window "Invalid popup name!" nowait
    return .f.
  endif
  if type("LNKEY")!="N"
    lnkey=1
  endif
  if type("LNROW")!="N"
    lnrow=1
  endif
  if type("LNCOL")!="N"
    lncol=1
  endif
  if type("LNHEIGHT")!="N"
    lnheight=min(alen(lasrc,1),10)
  endif
  if type("LNWIDTH")!="N"
    lnwidth=amaxlen(@lasrc,lnkey)+2
  endif
  lnsrows=alen(lasrc,1)
  lnscols=alen(lasrc,2)
  lnbar=1
  define popup (lcpopname);
    from lnrow, lncol;
    to lnrow+lnheight, lncol+lnwidth;
    scroll mover
  for lncnt1=1 to lnsrows
    if lnscols=0
      if type("LASRC(LNCNT1)")!="C"
        loop
      endif
      define bar lnbar of (lcpopname) prompt lasrc(lncnt1)
    else
      if type("LASRC(LNCNT1,LNKEY)")!="C"
        loop
      endif
      define bar lnbar of (lcpopname) prompt lasrc(lncnt1,lnkey)
    endif
    lnbar=lnbar+1
  endfor
return .t.


* FSTR(<number>)
*
* returns a floating point character value of <number>.
*
procedure fstr
parameters lnnum
private lnnum, lnint, lndec, lcdec, lcfstr
  if type("LNNUM")!="N"
    return ""
  endif
  lcfstr=alltrim(str(lnnum,237,18))
  lcdec=substr(lcfstr,at(".",lcfstr)+1)
  if val(lcdec)=0
    lcfstr=substr(lcfstr,1,at(".",lcfstr)-1)
  else
    do while right(lcfstr,1)="0"
      lcfstr=left(lcfstr,len(lcfstr)-1)
    enddo
  endif
return lcfstr

* _RELA()
*
* displays code for existing relations
*
procedure _rela
private laview, x
  dimension laview(1)
  =saveview(@laview)
  =_debug("ON")
  for x=1 to alen(laview)
    if empty(laview(x,6))
      loop
    endif
    \select <<laview(x,1)>>
    \set relation to <<laview(x,6)>>
  endfor
  =_debug("SHOW")
return

* TIMESTMP()
*
* produces timestamp found in scx and pjx files.
*
procedure timestmp
private lcdate, lctime
  lcdate=date()
  lctime=time()
return ((year(lcdate)-1980) * 2 ** 25)+;
       (month(lcdate) * 2 ** 21)+;
       (day(lcdate) * 2 ** 16)+;
       (val(left(lctime,2)) * 2 ** 11)+;
       (val(substr(lctime,4,2)) * 2 ** 5)+;
       val(right(lctime,2))

* _GETEXPR([<typeit>[,<textmerge>]])
*
* shows expression dialog and returns result.  if <typeit> is .t., it
* is sent to the keyboard buffer.  if <textmerge> is .t., the return
* expression is returned between << >>.
*
procedure _getexpr
parameters llkey, llmerge
private lcexpr
  getexpr to lcexpr
  lcexpr=iif(llmerge,"<<","")+lcexpr+iif(llmerge,">>","")
  if llkey
    keyboard lcexpr
  endif
return lcexpr
* _DEBUG([<switch>])
*
* sets textmerge to _DEBUG.TXT so that i can use "\"
* to send information to it.  sending "ON" and "OFF"
* switches them on and off.  "SHOW" turns textmerge off
* and displays the contents of _DEBUG.TXT
*
procedure _debug
parameters lccmd
private lccmd, lconerr
  if type("LCCMD")!="C"
    do case
      case set("TEXTMERGE")="ON" and set("TEXTMERGE",1)="_DEBUG.TXT"
        lccmd="OFF"
      case set("TEXTMERGE")="OFF" and (set("TEXTMERGE",1)="_DEBUG.TXT" or;
           empty(set("TEXTMERGE",1)))
        lccmd="ON"
      otherwise
        return .f.
    endcase
  endif
  lconerr=on("ERROR")
  lccmd=alltrim(upper(lccmd))
  if !inlist(lccmd,"ON","OFF","SHOW")
    return .f.
  endif
  do case
    case lccmd="ON"
      lnerr=0
      on error lnerr=error()
      set textmerge to _debug.txt
      if lnerr # 0
        wait window "Couldn't open _DEBUG.TXT" nowait
        on error &lconerr
        return .f.
      endif
      set textmerge on noshow
    case lccmd $ "OFF|SHOW"
      set textmerge off
      set textmerge to
      if lccmd="SHOW"
        modify file _debug.txt nowait
      endif
  endcase
return

*ABROWSE(@<array>)
*
*Allows you to browse the contents of an array in a
*browse.  If <expl> is true, the cursor is kept open,
*otherwise it is closed.
*Calls ACURS()
*
procedure abrowse
parameters lasrc, llkeep
private lasrc, lcalias
  lcalias=alias()
  if type("LASRC(1)")="U" or !acurs(@lasrc)
    return .f.
  endif
  browse normal nowait in screen
return .t.


* BROWSEIT
*
* simple browse
*
procedure browseit
  browse
return
